#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "adfulo.h"
#include "help.h"

extern char lgc_name[ LGCNAMELEN + 1 ];

extern char tv[ TVMAX ][ TVNAMELEN + 1 ];
extern int tvnum;
extern int maxlen;

extern long dtv;

extern struct op_list *op;
extern struct qu_list *qu;
extern struct ord_list *ord;

int complete( char *str )
{
   int i;

   for ( i = strlen( str ) - 1; i >= 0; i-- )
      if ( *( str + i ) == NOT_INITIALIZED ) return( 0 );
   return( 1 );
} /* complete */

char *type2str( int which )
{
   switch( which )
   {
      case GLB: return "glb";
      case INF: return "inf";
      case LUB: return "lub";
      case SUP: return "sup";
      default: return "\0";
   }
} /* type2str */

int general_scroll_menu( int wx, int wy, int length, int init_pos, int bkg,
			 int fg, int boxtype, int which )
{
   int h_m = 0, i, ret;
   char **str;
   struct op_list *hop;
   struct qu_list *hqu;
   struct ord_list *hord;

   switch( which )
   {
      case TRUTH_VALUES: h_m = tvnum; break;
      case OPERATORS: for ( hop = op; hop != NULL; hop = hop->next ) h_m += 1;
	 break;
      case QUANTIFIERS: for ( hqu = qu; hqu != NULL; hqu = hqu->next ) h_m += 1;
	 break;
      case ORDERINGS: for ( hord = ord; hord != NULL; hord = hord->next ) h_m += 1;
	 break;
      case BIN_OPS: h_m = 4; break;
      default: return( -1 );
   }
   if ( h_m == 0 ) return( -1 );
   str = (char **)malloc( sizeof( char * ) * h_m );
   if ( str == NULL )
   {
      display_error( "Out of memory. Cannot create scroll menu." );
      return( -1 );
   }
   switch( which )
   {
      case TRUTH_VALUES:
	 for ( i = 0; i < h_m; i++ )
	 {
	    str[ i ] = (char *)malloc( sizeof( char ) * ( strlen( tv[ i ] ) + 1 ) );
	       if ( str[ i ] == NULL )
	       {
		  display_error( "Out of memory. Cannot create scroll menu." );
		  return( -1 );
	       }
	    sprintf( str[ i ], "%s", tv[ i ] );
	 }
	 break;
      case OPERATORS:
	 for ( i = 0, hop = op; hop != NULL; hop = hop->next, i++ )
	 {
	    str[ i ] = (char *)malloc( sizeof( char ) *
		       ( strlen( hop->o.opname ) + 4 ) );
	       if ( str[ i ] == NULL )
	       {
		  display_error( "Out of memory. Cannot create scroll menu." );
		  return( -1 );
	       }
	    sprintf( str[ i ], "%s/%d", hop->o.opname, hop->o.arity );
	 }
	 break;
      case QUANTIFIERS:
	 for ( i = 0, hqu = qu; hqu != NULL; hqu = hqu->next, i++ )
	 {
	    str[ i ] = (char *)malloc( sizeof( char ) *
		       ( strlen( hqu->q.quname ) + 3 ) );
	       if ( str[ i ] == NULL )
	       {
		  display_error( "Out of memory. Cannot create scroll menu." );
		  return( -1 );
	       }
	    sprintf( str[ i ], "%s/q", hqu->q.quname );
	 }
	 break;
      case ORDERINGS:
	 for ( i = 0, hord = ord; hord != NULL; hord = hord->next, i++ )
	 {
	    str[ i ] = (char *)malloc( sizeof( char ) *
		       ( strlen( hord->or.ordname ) + 5 ) );
	       if ( str[ i ] == NULL )
	       {
		  display_error( "Out of memory. Cannot create scroll menu." );
		  return( -1 );
	       }
	    sprintf( str[ i ], "%s/ord", hord->or.ordname );
	 }
	 break;
      case BIN_OPS:
	 for ( i = 0; i < 4; i++ )
	 {
	    str[ i ] = (char *)malloc( sizeof( char ) * 4 );
	       if ( str[ i ] == NULL )
	       {
		  display_error( "Out of memory. Cannot create scroll menu." );
		  return( -1 );
	       }
	    sprintf( str[ i ], "%s", type2str( i + GLB ) );
	 }
	 break;
      default:;
   }
   ret = scroll_menu( str, h_m, wx, wy, length, init_pos, bkg, fg, boxtype );
   for ( i = 0; i < h_m; i++ ) free( str[ i ] );
   free( str );
   return( ret );
} /* general_scroll_menu */

void prepare_default_window( int x1, int y1, int x2, int y2, char *title,
			     struct window_borders *wb )
{
   *wb = create_window( x1, y1, x2, y2, LIGHTGRAY, BLACK, DOUBLE_LINE_BOX, title );
   ( void ) create_window( x1 + 1, y2 - 3, x2 - 1, y2 - 1, LIGHTGRAY, BLACK,
			   SINGLE_LINE_BOX, 0 );
   focus_on_window( *wb );
} /* prepare_default_window */

int how_many_operators()
{
   struct op_list *h;
   int i = 0;

   h = op;
   while ( h != NULL ) i += 1, h = h->next;
   return( i );
}

int how_many_quantifiers()
{
   struct qu_list *h;
   int i = 0;

   h = qu;
   while ( h != NULL ) i += 1, h = h->next;
   return( i );
}

int how_many_orderings()
{
   struct ord_list *h;
   int i = 0;

   h = ord;
   while ( h != NULL ) i += 1, h = h->next;
   return( i );
}

struct operator *operator_exists( char *dopname, int darity )
{
   struct op_list *help;

   for ( help = op; help != NULL; help = help->next )
      if ( strcmp( dopname, help->o.opname ) == 0 &&
	 darity == help->o.arity ) return ( &help->o );
   return( 0 );
}

struct quantifier *quantifier_exists( char *dquname )
{
   struct qu_list *help;

   for ( help = qu; help != NULL; help = help->next )
      if ( strcmp( dquname, help->q.quname ) == 0 ) return ( &help->q );
   return( 0 );
}

struct ordering *ordering_exists( char *dordname )
{
   struct ord_list *help;

   for ( help = ord; help != NULL; help = help->next )
      if ( strcmp( dordname, help->or.ordname ) == 0 ) return ( &help->or );
   return( 0 );
}

int hook_operator( char *dopname, int darity, int dtype )
{
   struct op_list *help, *help2, *help3;
   int i;
   char *s;

   help = (struct op_list *)malloc( sizeof( struct op_list ) );
   if ( help == NULL )
      return( 0 );
   if ( dtype == TABLE || dtype == MAPPING )
   {
      help->o.power = (unsigned int) pow( (double) tvnum, (double) darity );
      help->o.list = ( char * )malloc( sizeof( char ) * ( help->o.power + 1 ) );
      if ( help->o.list == NULL )
	 return( 0 );
      for ( i = 0; i < help->o.power; i++)
	 *( help->o.list + i ) = NOT_INITIALIZED;
      s = help->o.list + i;
      *s = '\0';
   }
   else
   {
      *( help->o.list ) = '\0';
      help->o.power = 0;
   }
   strcpy( help->o.opname, dopname );

   help->next = NULL;
   help->o.typ = dtype;
   strcpy( help->o.ordname, "\0" );
   help->o.arity = darity;
   if ( op != NULL )
   {
      if ( op->next == NULL )
      {
	 if ( darity < op->o.arity || ( darity == op->o.arity &&
	 strcmp( dopname, op->o.opname ) < 0 ) )
	 {
	    help2 = op;
	    op = help;
	    help->next = help2;
	 }
	 else op->next = help;
      }
      else
      {
	 help2 = op; help3 = op;
	 while ( help2->next != NULL && ( darity > help2->o.arity ||
	 darity == help2->o.arity && strcmp( help2->o.opname, dopname ) < 0 ) )
	 {
	    help3 = help2;
	    help2 = help2->next;
	 }
	 if ( help2->next == NULL )
	 {
	    if ( darity < help2->o.arity || ( darity == help2->o.arity &&
	    strcmp( dopname, help2->o.opname ) < 0 ) )
	    {
	       help3->next = help;
	       help->next = help2;
	    }
	    else help2->next = help;
	 }
	 else
	 {
	    if ( help2 == op )
	    {
	       op = help;
	       help->next = help2;
	    }
	    else
	    {
	       help3->next = help;
	       help->next = help2;
	    }
	 }
      }
   }
   else
      op = help;
   return( 1 );
} /* hook_operator */

int hook_quantifier( char *dquname, int dtype )
{
   struct qu_list *help, *help2, *help3;
   int i;
   char *s;

   help = (struct qu_list *)malloc( sizeof( struct qu_list ) );
   if ( help == NULL )
      return( 0 );
   if ( dtype == MAPPING )
   {
      help->q.power = (unsigned int) pow( (double) 2, (double) tvnum ) - 1;
      help->q.list = ( char * )malloc( sizeof( char ) * ( help->q.power + 1 ) );
      if ( help->q.list == NULL )
	 return( 0 );
      for ( i = 0; i < help->q.power; i++)
	 *( help->q.list + i ) = NOT_INITIALIZED;
      s = help->q.list + i;
      *s = '\0';
   }
   else
   {
      help->q.power = 0;
      *( help->q.list ) = '\0';
   }
   strcpy( help->q.quname, dquname );
   help->next = NULL;
   help->q.typ = dtype;
   help->q.arity = -1;
   strcpy( help->q.oporord, "\0" );
   if ( qu != NULL )
   {
      if ( qu->next == NULL )
      {
	 if ( strcmp( dquname, qu->q.quname ) < 0 )
	 {
	    help2 = qu;
	    qu = help;
	    help->next = help2;
	 }
	 else qu->next = help;
      }
      else
      {
	 help2 = qu; help3 = qu;
	 while ( help2->next != NULL && strcmp( help2->q.quname, dquname ) < 0 )
	 {
	    help3 = help2;
	    help2 = help2->next;
	 }
	 if ( help2->next == NULL )
	 {
	    if ( strcmp( dquname, help2->q.quname ) < 0 )
	    {
	       help3->next = help;
	       help->next = help2;
	    }
	    else help2->next = help;
	 }
	 else
	 {
	    if ( help2 == qu )
	    {
	       qu = help;
	       help->next = help2;
	    }
	    else
	    {
	       help3->next = help;
	       help->next = help2;
	    }
	 }
      }
   }
   else
      qu = help;
   return( 1 );
} /* hook_quantifier */

int hook_ordering( char *dordname )
{
   struct ord_list *help, *help2, *help3;

   help = (struct ord_list *)malloc( sizeof( struct ord_list ) );
   if ( help == NULL )
      return( 0 );
   strcpy( help->or.ordname, dordname );
   strcpy( help->or.list, "\0" );
   help->next = NULL;
   if ( ord != NULL )
   {
      if ( ord->next == NULL )
      {
	 if ( strcmp( dordname, ord->or.ordname ) < 0 )
	 {
	    help2 = ord;
	    ord = help;
	    help->next = help2;
	 }
	 else ord->next = help;
      }
      else
      {
	 help2 = ord; help3 = ord;
	 while ( help2->next != NULL && strcmp( help2->or.ordname, dordname ) < 0 )
	 {
	    help3 = help2;
	    help2 = help2->next;
	 }
	 if ( help2->next == NULL )
	 {
	    if ( strcmp( dordname, help2->or.ordname ) < 0 )
	    {
	       help3->next = help;
	       help->next = help2;
	    }
	    else help2->next = help;
	 }
	 else
	 {
	    if ( help2 == ord )
	    {
	       ord = help;
	       help->next = help2;
	    }
	    else
	    {
	       help3->next = help;
	       help->next = help2;
	    }
	 }
      }
   }
   else
      ord = help;
   return( 1 );
} /* hook_ordering */

int unhook_operator( struct op_list *off )
{
   struct op_list *help, *help2;

   if ( off == NULL || op == NULL ) return( 0 );
   if ( op == off )
   {
      help = op;
      op = op->next;
      if ( help->o.typ == TABLE || help->o.typ == MAPPING )
	 free( help->o.list );
      free( help );
      return( 1 );
   }
   else
   {
      help = op;
      while ( help->next != NULL && help->next != off )
      {
	 help = help->next;
      }
      if ( help->next == off )
      {
	 help2 = help->next->next;
	 if ( help->next->o.typ == TABLE || help->next->o.typ == MAPPING )
	    free( help->next->o.list );
	 free( help->next );
	 help->next = help2;
	 return( 1 );
      }
   }
   return( 0 );
} /* unhook_operator */

int unhook_quantifier( struct qu_list *off )
{
   struct qu_list *help, *help2;

   if ( off == NULL || qu == NULL ) return( 0 );
   if ( qu == off )
   {
      help = qu;
      qu = qu->next;
      if ( help->q.typ == MAPPING )
	 free( help->q.list );
      free( help );
      free( help );
      return( 1 );
   }
   else
   {
      help = qu;
      while ( help->next != NULL && help->next != off )
      {
	 help = help->next;
      }
      if ( help->next == off )
      {
	 help2 = help->next->next;
	 if ( help->next->q.typ == MAPPING )
	    free( help->next->q.list );
	 free( help->next );
	 help->next = help2;
	 return( 1 );
      }
   }
   return( 0 );
} /* unhook_quantifier */

int unhook_ordering( struct ord_list *off )
{
   struct ord_list *help, *help2;

   if ( off == NULL || ord == NULL ) return( 0 );
   if ( ord == off )
   {
      help = ord;
      ord = ord->next;
      free( help );
      return( 1 );
   }
   else
   {
      help = ord;
      while ( help->next != NULL && help->next != off )
      {
	 help = help->next;
      }
      if ( help->next == off )
      {
	 help2 = help->next->next;
	 free( help->next );
	 help->next = help2;
	 return( 1 );
      }
   }
   return( 0 );
} /* unhook_ordering */

int ordering_used( char *dordname )
{
   struct op_list *hop;
   struct qu_list *hqu;

   hop = op;
   while ( hop != NULL )
   {
      if ( hop->o.typ >= GLB && hop->o.typ <= SUP &&
      strcmp( hop->o.ordname, dordname ) == 0 )
	 return( 1 );
      hop = hop->next;
   }
   hqu = qu;
   while ( hqu != NULL )
   {
      if ( hqu->q.typ >= GLB && hqu->q.typ <= SUP &&
      strcmp( hqu->q.oporord, dordname ) == 0 )
	 return( 1 );
      hqu = hqu->next;
   }
   return( 0 );
} /* ordering_used */

int operator_used( char *dopname )
{
   struct qu_list *hqu;

   hqu = qu;
   while ( hqu != NULL )
   {
      if ( hqu->q.typ == INDUCED_BY_OPERATOR &&
      strcmp( hqu->q.oporord, dopname ) == 0 )
	 return( 1 );
      hqu = hqu->next;
   }
   return( 0 );
} /* operator_used */

void big_title()
{
   char d[ LGCNAMELEN + 3 ] = "\0";

   if ( strlen( lgc_name ) ) sprintf( d, " %s ", lgc_name );
   create_window( 1, 2, 80, 24, BLACK, LIGHTRED, SINGLE_LINE_BOX, d );
}