/* Includes ********************************************************/
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "adfulo.h"
#include "order.h"
#include "edit.h"
#include "help.h"
#include "create.h"


/* Variables ********************************************************/

extern char lgc_name[ LGCNAMELEN + 1 ];

extern char tv[ TVMAX ][ TVNAMELEN + 1 ];
extern int tvnum;
extern int maxlen;

extern struct op_list *op;
extern struct qu_list *qu;
extern struct ord_list *ord;

extern unsigned char changed;

int edit_tv()
{
   struct window_borders wb, dis;
   int i, j, c, leave_ok = 0, k, exc, d;
   char dummy[ 80 ];
   char btv[ TVMAX ][ TVNAMELEN + 1 ];
   int bmaxlen;

   for ( i = 0; i < TVMAX; i++ ) strcpy( btv[ i ], tv[ i ] );
   bmaxlen = maxlen;
   save_screen();
   i = ( TVNAMELEN + 7 )*( tvnum >= 3 ? 3 : tvnum );
   j = i/2;
   prepare_default_window( 37 - max( j, 15 ), GENERAL_UPPER_Y + 4, 43 + max( j, 15 ),
   GENERAL_UPPER_Y + tvnum/3 + !!( tvnum%3 ) + 10,
   " Enter truth values ", &wb );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   dis = create_window( 40 - j, GENERAL_UPPER_Y + 5, 40 + j + !!( i%2 ),
			GENERAL_UPPER_Y + tvnum/3 + !!(tvnum%3) + 6,
			LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   for ( i = 0; i < tvnum/3 + !!( tvnum%3 ); i++ )
      for ( j = 0; j < 3 && j + 3*i < tvnum; j++ )
      {
	 focus_on_window( dis );
	 gotoxy( j*( TVNAMELEN + 6 ) + 2, i + 2 );
	 cprintf( "%3d:", j + 3*i + 1 );
	 create_window( dis.x1 + j*( TVNAMELEN + 6 ) + 5, dis.y1 + i + 1,
	 dis.x1 + 6 + ( j + 1 )*TVNAMELEN + j*6, dis.y1 + i + 1, BLACK,
	 WHITE, NO_BOX, 0 );
	 cprintf( ">%s", tv[ 3*i + j ] );
      }
   i = 0;
   j = 0;
   do
   {
      c = -ESC;
      do
      {
	 strcpy( tv[ j*3 + i ], read_in_string( dis.x1 + i*( TVNAMELEN + 6 ) + 5,
	 dis.y1 + j + 1, TVNAMELEN + 1, 0, BLACK, WHITE, tv[ j*3 + i ], &exc ) );
	 switch( exc )
	 {
	    case UP:
	       if ( j > 0 ) j -= 1; break;
	    case DOWN:
	       if ( j*3 + i + 3 < tvnum ) j += 1;
	       else exc = ESC; break;
	    case RETURN:
	    case RIGHT:
	       if ( i < 2 && j*3 + i + 1 < tvnum ) i += 1;
	       else if ( i == 2 && ( j + 1 )*3 < tvnum )
	       {
		  i = 0;
		  j += 1;
	       }
	       break;
	    case LEFT:
	       if ( i > 0 ) i -= 1;
	       else if ( j > 0 )
	       {
		  j -= 1;
		  i = 2;
	       }
	       break;
	    case PGUP : j = 0; break;
	    case PGDOWN: j = tvnum/3;
	       if ( j*3 + i >= tvnum ) j -= 1;
	       break;
	 }
      }
      while ( exc != ESC );
      focus_on_window( wb );
      c = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	  !JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
      if ( c < 0 ) c = -ESC;
      k = 0; leave_ok = 1;
      while ( k < tvnum && leave_ok == 1 )
      {
	 d = re2( tv[ k ] );
	 if ( d >= -1 )
	 {
	    if ( d == -1 )
	       sprintf( dummy, "Truth value %d is empty.", k + 1 );
	    else sprintf( dummy, "Truth value %d doesn't match regular expression.", k + 1 );
	    leave_ok = 0;
	 }
	 k += 1;
      }
      k = 1;
      while ( k < tvnum && leave_ok == 1 )
      {
	 for ( d = 0; d < k && leave_ok == 1; d++ )
	    if ( strcmp( tv[ d ], tv[ k ] ) == 0 )
	    {
	       sprintf( dummy, "Truth values %d and %d equal.", d + 1, k + 1 );
	       leave_ok = 0;
	    }
	 k += 1;
      }
      if ( c == DO_ACCEPT && leave_ok == 0 ) confirm( dummy, 1 );
      focus_on_window( dis );
   }
   while ( !( c == DO_CANCEL || ( c == DO_ACCEPT && leave_ok ) ) );
   restore_screen();
   if ( c == DO_CANCEL )
   {
      for ( i = 0; i < TVMAX; i++ ) strcpy( tv[ i ], btv[ i ] );
      maxlen = bmaxlen;
   }
   else
   {
      maxlen = 0;
      for ( i = 0; i < tvnum; i++ )
	 if ( strlen( tv[ i ] ) > maxlen ) maxlen = strlen( tv[ i ] );
   }
   return( leave_ok );
} /* edit_tv */

/*
   Name       : enter_truth_values.
   Function   : selfexplaining.
*/

void enter_truth_values()
{
   int exc;
   int i, j, which = 0, leave_ok = 0, c;
   char buffer[ 67 ], dummy[ 80 ];
   struct window_borders wb;
   char btv[ TVMAX ][ TVNAMELEN + 1 ];
   int bmaxlen, btvnum, bbtvnum;

   if ( op != NULL || qu != NULL || ord != NULL )
   {
      if ( op != NULL ) strcpy( buffer, "operators" );
      else if ( qu != NULL ) strcpy( buffer, "quantifiers" );
      else if ( ord != NULL ) strcpy( buffer, "orderings" );
      sprintf( dummy,
      "Impossible to change truth values, when %s already defined.", buffer );
      ( void ) confirm( dummy, 1 );
      main_window();
      return;
   }
   for ( i = 0; i < TVMAX; i++ )
   {
      strcpy( btv[ i ], tv[ i ] );
      strcpy( tv[ i ], "\0" );
   }
   btvnum = tvnum;
   bmaxlen = maxlen;
   prepare_default_window( 20, GENERAL_UPPER_Y, 60, GENERAL_UPPER_Y + 9,
			   " Create truth values ", &wb );
   gotoxy( 3, 3 );
   cprintf( "Number of truth values: " );
   gotoxy( 10, 5 );
   cprintf( "< Edit truth values >" );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   focus_on_window( wb );
   which = 0;
   c = -ESC;
   do
   {
      switch( which )
      {
	 case 0:
	    bbtvnum = tvnum;
	    read_in_int( &tvnum, 46, 5, 2, 2, TVMAX, BLACK, WHITE, tvnum, &exc );
	    if ( bbtvnum != tvnum )
	    {
	       for ( i = 0; i < tvnum; i++ ) strcpy( tv[ i ], "\0" );
	       leave_ok = 0;
	    }
	    focus_on_window( wb );
	    switch( exc )
	    {
	       case RETURN:
	       case DOWN:
	       case RIGHT:
	       case TAB:
		  which = 1; break;
	       case LEFT:
	       case SHIFT_TAB:
	       case ESC:
	       case UP: which = 2; break;
	       default:;
	    }
	    break;
	 case 1:
	    inverse( 10, 5, "< Edit truth values >", LIGHTGRAY );
	    cursor( 0 );
	    i = get_key();
	    cursor( 1 );
	    inverse( 10, 5, "< Edit truth values >", LIGHTGRAY*16 );
	    switch( i )
	    {
	       case RETURN:
		  i = edit_tv();
		  focus_on_window( wb );
		  switch( i )
		  {
		     case 1: leave_ok = 1; break;
		     case 0: leave_ok = 0; break;
		  }
		  break;
	       case LEFT:
	       case UP:
	       case SHIFT_TAB: which -= 1; break;
	       case RIGHT:
	       case DOWN:
	       case TAB:
	       case ESC: which += 1; break;
	    }
	    break;
	 case 2:
	    c = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2,
		wb.x2 - wb.x1- 3, !JUST_INIT, OUT, NO_INIT_POS, 2, "Accept",
		"Cancel" );
	    focus_on_window( wb );
	    switch( c )
	    {
	       case -LEFT:
	       case -SHIFT_TAB:
	       case -UP: which -= 1; break;
	       case -RIGHT:
	       case -DOWN:
	       case -TAB: which = 0; break;
	       case DO_ACCEPT:
		  if ( !leave_ok )
		  {
		     confirm( "Truth values not completely defined.", 1 );
		     focus_on_window( wb );
		     c = -ESC;
		  }
		  else
		  {
		     int ddd;

		     ddd = (int) ceil( ( 73 - max( maxlen, 5 ) )/
			       ( maxlen + 2 ) );
		     if ( ddd < MAX_ARITY )
		     {
			char big_dummy[ 200 ];

			sprintf( big_dummy, "No operator as mapping with arity"
				" greater than %d possible due to long "
				" truthvalue name(s). Accept?", ddd );
			if ( confirm( big_dummy, 2 ) == 1 )
			   c = -ESC;
		     }
		     if ( leave_ok )
		     {
			ddd = 4 + max( maxlen, 5 );
			for ( i = 0; i < tvnum; i++ )
			   ddd += strlen( tv[ i ] ) + 2;
			if ( ddd > 77 || tvnum >= 17 )
			{
			   if ( confirm( "No quantifier as mapping possible. "
			   "Accept?", 2 ) == 1 )
			      c = -ESC;
			}
		     }
		  }
		  break;
	       default:;
	    }
	    break;
	 default:;
      }
   }
   while ( c < 0 );
   if ( c == DO_CANCEL )
   {
      tvnum = btvnum;
      maxlen = bmaxlen;
      for ( i = 0; i < TVMAX; i++ )
	 strcpy( tv[ i ], btv[ i ] );
   }
   else
      changed = 1;
   main_window();
} /* enter_truth_values */

/*
   Name       : enter_lgc_name.
   Function   : selfexplaining.
*/

void enter_lgc_name()
{
   char buffer[ 80 ], backup[ LGCNAMELEN + 1 ];
   int c, exc;
   struct window_borders wb;

   strcpy( backup, lgc_name );
   prepare_default_window( 13, GENERAL_UPPER_Y, 67, GENERAL_UPPER_Y + 7,
			   " Create logic name ", &wb );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   focus_on_window( wb );
   gotoxy( 8, 3 );
   cprintf( "Logic name: " );
   do
   {
      strcpy( lgc_name, read_in_string( 32, GENERAL_UPPER_Y + 2,
	      LGCNAMELEN + 1, 0, BLACK, WHITE, lgc_name, &exc ) );
      c = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
			!JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   }
   while ( c < 0 );
   if ( c == DO_CANCEL ) strcpy( lgc_name, backup );
   else
   {
      changed = 1;
      big_title();
   }
   main_window();
} /* enter_lgc_name */

/*
   Name       : create_operator.
   Function   : create a new operator.
*/

void create_operator()
{
   char dopname[ OPNAMELEN + 1 ] = "\0";
   struct window_borders wb;
   int darity = 0, exc, which, c = DO_EDIT, cc, ccc, dtype = MAPPING;

   if ( !tvnum )
   {
      confirm( "Truth values have to be defined first.", 1 );
      main_window();
      return;
   }
   prepare_default_window( 15, GENERAL_UPPER_Y, 65, GENERAL_UPPER_Y + 13,
			   " Create operator ", &wb );

   gotoxy( 9, 3 );
   cprintf( "Operator name: " );
   gotoxy( 9, 5 );
   cprintf( "        Arity: 0" );
   gotoxy( 9, 7 );
   cprintf( "         Type: mapping       " );
   ( void ) ok_or_cancel( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS );
   ( void ) create_window( 38, GENERAL_UPPER_Y + 2, 38 + OPNAMELEN + 1,
			   GENERAL_UPPER_Y + 2, BLACK, WHITE, NO_BOX, 0 );
   cprintf( ">" );
   ( void ) create_window( 46, GENERAL_UPPER_Y + 4, 49, GENERAL_UPPER_Y + 4,
			   BLACK, WHITE, NO_BOX, 0 );
   ( void ) create_window( wb.x1 + 1, GENERAL_UPPER_Y + 7, wb.x2 - 1,
			   GENERAL_UPPER_Y + 9, LIGHTGRAY, BLACK,
			   SINGLE_LINE_BOX, 0 );
   horizontal_select_menu( wb.x1 + 2, GENERAL_UPPER_Y + 8, wb.x2 - wb.x1 - 3,
   JUST_INIT, OUT, NO_INIT_POS,  1 + !!( darity >= 2 ) + !!( darity == 2 ),
   "mapping", "induced by", "table" );
   which = 0;
   do
   {
      c = -ESC;
      do
      {
	 switch( which )
	 {
	    case 0:
	       strcpy( dopname, read_in_string( 38, GENERAL_UPPER_Y + 2,
		       OPNAMELEN + 1, 0, BLACK, WHITE, dopname, &exc ) );
	       switch( exc )
	       {
		  case TAB:
		  case RETURN:
		  case DOWN:
		  case RIGHT: which = 1; break;
		  case ESC:
		  case SHIFT_TAB:
		  case UP:
		  case LEFT: which = 3; break;
	       }
	       break;
	    case 1:
	       read_in_int( &darity, 46, GENERAL_UPPER_Y + 4, 2, 0,
			    MAX_ARITY, BLACK, WHITE, darity, &exc );
	       focus_on_window( wb );
	       gotoxy( 24, 5 ); cprintf( "%-2d", darity );
	       if ( ( darity != 2 && dtype == TABLE ) ||
		  ( darity < 2 && dtype != MAPPING ) )
		  OUTXY( 24, 7, "mapping       " );
	       horizontal_select_menu( wb.x1 + 2, GENERAL_UPPER_Y + 8,
	       wb.x2 - wb.x1 - 3, JUST_INIT, OUT, 0, 1 + !!( darity >= 2 ) +
	       !!( darity == 2 ), "mapping", "induced by", "table" );
	       switch( exc )
	       {
		  case TAB:
		  case RETURN:
		  case DOWN:
		  which = 2; break;
		  case ESC: which = 3; break;
		  case SHIFT_TAB:
		  case UP: which = 0; break;
	       }
	       break;
	    case 2:
	       cc = horizontal_select_menu( wb.x1 + 2, GENERAL_UPPER_Y + 8,
		   wb.x2 - wb.x1 - 3, !JUST_INIT, OUT, NO_INIT_POS, 1 +
		   !!( darity >= 2 ) + !!( darity == 2 ), "mapping",
		   "induced by", "table" );
	       focus_on_window( wb );
	       switch( cc )
	       {
		  case 0: gotoxy( 24, 7 ); cprintf( "mapping       " );
		     dtype = MAPPING; break;
		  case 2: gotoxy( 24, 7 ); cprintf( "table         " );
		     dtype = TABLE; break;
		  case 1:
		     save_screen();
		     ccc = general_scroll_menu( 2, 3, 4, 0, LIGHTGRAY, BLACK,
			 SINGLE_LINE_BOX, 4 );
		     restore_screen();
		     focus_on_window( wb );
		     if ( ccc >= 0 )
		     {
			dtype = ccc + GLB;
			gotoxy( 24, 7 );
			cprintf( "induced by %s  ", type2str( dtype ) );
		     }
		     break;
	       }
	       switch( cc )
	       {
		  case -LEFT:
		  case -SHIFT_TAB:
		  case -UP: which -= 1; break;
		  default: which += 1; break;
	       }
	       break;
	    case 3:
	       c = ok_or_cancel( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
		   !JUST_INIT, OUT, NO_INIT_POS );
	       switch( c )
	       {
		  case -ESC:
		  case -TAB:
		  case -RIGHT:
		  case DO_EDIT:
		  case -DOWN: which = 0; break;
		  case -SHIFT_TAB:
		  case -LEFT:
		  case -UP: which -= 1; break;
	       }
	       break;
	    default:;
	 }
      }
      while ( c < 0 );
      if ( c == DO_ACCEPT || c == DO_EDIT )
      {
	 if ( ( exc = re2( dopname ) ) >= -1 )
	 {
	    add_help( H_E_RE2 );
	    if ( exc == -1 )
	       ( void ) confirm( "Operator name must not be empty.", 1 );
	    else
	       ( void ) confirm( "Name doesn't match regular expression for operator name.", 1 );
	    c = -ESC;
	    which = 0;
	    remove_help();
	 }
	 else if ( ( dtype == TABLE || dtype == MAPPING ) &&
	 pow( (double) tvnum, (double) darity ) >= 65536.0 )
	 {
	    ( void ) confirm( "Impossible to store amount of entries for this operator.", 1 );
	    c = -ESC;
	    which = 1;
	 }
	 else if ( operator_exists( dopname, darity ) )
	 {
	    ( void ) confirm( "Operator already exists.", 1 );
	    c = -ESC;
	    which = 0;
	 }
	 else if ( dtype == MAPPING && ( ( maxlen + 2 )*darity +
	 max( maxlen, 5 ) > 73 ) )
	 {
	    char dummy[ 120 ];

	    sprintf( dummy, "Impossible to create operator as mapping with "
		     "arity %d due to long truth value names.", darity );
	    ( void ) confirm( dummy, 1 );
	    c = -ESC;
	    which = 1;
	 }
      }
   }
   while ( c == -ESC );
   if ( c == DO_ACCEPT || c == DO_EDIT )
   {
      if ( !hook_operator( dopname, darity, dtype ) )
	 display_error( "Out of memory. Cannot create new operator." );
      else if ( c == DO_EDIT )
      {
	 changed = 1;
	 main_window();
	 switch( dtype )
	 {
	    case MAPPING:
	       general_mapping_edit( OPERATORS, operator_exists( dopname, darity ) );
	       break;
	    case TABLE:
	       edit_operator_as_table( operator_exists( dopname, darity ) );
	       break;
	    case GLB:
	    case INF:
	    case LUB:
	    case SUP:
	       general_induced_by_ordering_edit( OPERATORS, operator_exists( dopname, darity ) );
	       break;
	    default:;
	 }
      }
   }
   main_window();
} /* create_operator */

/*
   Name       : create_quantifier.
   Function   : create a new quantifier.
*/

void create_quantifier()
{
   char dquname[ QUNAMELEN + 1 ] = "";
   struct window_borders wb;
   int darity, exc, which = 0;
   int i, c, cc, ccc, dtype = MAPPING;

   if ( !tvnum )
   {
      confirm( "Truth values have to be defined first.", 1 );
      main_window();
      return;
   }
   prepare_default_window( 13, GENERAL_UPPER_Y, 68, GENERAL_UPPER_Y + 11,
			   " Create quantifier ", &wb );
   gotoxy( 7, 3 );
   cprintf( "Quantifier name: " );
   gotoxy( 7, 5 );
   cprintf( "           Type: mapping            ");
   ( void ) create_window( 36, GENERAL_UPPER_Y + 2, 36 + QUNAMELEN + 1,
			   GENERAL_UPPER_Y + 2, BLACK, WHITE, NO_BOX, 0 );
   cprintf( ">" );
   ( void ) create_window( wb.x1 + 1, GENERAL_UPPER_Y + 5, wb.x2 - 1,
			   GENERAL_UPPER_Y + 7, LIGHTGRAY, BLACK,
			   SINGLE_LINE_BOX, 0 );
   ( void ) ok_or_cancel( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS );
   which = 0;
   do
   {
      c = -ESC;
      do
      {
	 switch( which )
	 {
	    case 0:
	       strcpy( dquname, read_in_string( 36, GENERAL_UPPER_Y + 2,
		       QUNAMELEN + 1, 0, BLACK, WHITE, dquname, &exc ) );
	       switch( exc )
	       {
		  case TAB:
		  case RETURN:
		  case RIGHT:
		  case DOWN: which = 1; break;
		  case ESC:
		  case SHIFT_TAB:
		  case LEFT:
		  case UP: which = 2; break;
	       }
	       break;
	    case 1:
	       cc = horizontal_select_menu( wb.x1 + 2, GENERAL_UPPER_Y + 6,
		    wb.x2 - wb.x1 - 3, 0, 1, 0,  3,
		    "mapping", "ind by ordering", "ind by operator" );
	       focus_on_window( wb );
	       switch( cc )
	       {
		  case 0: gotoxy( 24, 5 ); cprintf( "mapping            " );
		     dtype = MAPPING; break;
		  case 2: gotoxy( 24, 5 ); cprintf( "induced by operator" );
		     dtype = INDUCED_BY_OPERATOR; break;
		  case 1:
		     save_screen();
		     ccc = general_scroll_menu( 2, 3, 4, 0, LIGHTGRAY, BLACK,
			 SINGLE_LINE_BOX, 4 );
		     restore_screen();
		     focus_on_window( wb );
		     if ( ccc >= 0 )
		     {
			dtype = ccc + GLB;
			gotoxy( 24, 5 );
			cprintf( "induced by %-8s", type2str( dtype ) );
		     }
		     break;
	       }
	       switch( cc )
	       {
		  case -LEFT:
		  case -SHIFT_TAB:
		  case -UP: which -= 1; break;
		  default: which += 1; break;
	       }
	       break;
	    case 2:
	       c = ok_or_cancel( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
		   !JUST_INIT, OUT, NO_INIT_POS );
	       switch( c )
	       {
		  case -ESC:
		  case -TAB:
		  case -RIGHT:
		  case DO_EDIT:
		  case -DOWN: which = 0; break;
		  case -SHIFT_TAB:
		  case -LEFT:
		  case -UP: which -= 1; break;
	       }
	       break;
	    default:;
	 }
      }
      while ( c < 0 );
      if ( c == DO_ACCEPT || c == DO_EDIT )
      {
	 if ( ( exc = re2( dquname ) ) >= -1 )
	 {
	    add_help( H_E_RE2 );
	    if ( exc == -1 )
	       ( void ) confirm( "Quantifier name must not be empty.", 1 );
	    else
	       ( void ) confirm( "Name doesn't match regular expression for quantifier name.", 1 );
	    c = -ESC;
	    which = 0;
	    remove_help();
	 }
	 else if ( dtype == MAPPING  && tvnum >= 17 )
	 {
	    ( void ) confirm( "Impossible to create mapping with more than 16 truth values.", 1 );
	    c = -ESC;
	    which = 1;
	 }
	 else if ( quantifier_exists( dquname ) )
	 {
	    ( void ) confirm( "Quantifier already exists.", 1 );
	    c = -ESC;
	    which = 0;
	 }
	 else if ( dtype == MAPPING )
	 {
	    int ddd;

	    ddd = 4 + max( maxlen, 5 );
	    for ( i = 0; i < tvnum; i++ )
	       ddd += strlen( tv[ i ] ) + 2;
	    if ( ddd > 77 )
	    {
	       ( void ) confirm( "No quantifier as mapping possible.", 1 );
	       c = -ESC;
	       which = 1;
	    }
	 }
      }
   }
   while ( c == -ESC );
   if ( c == DO_ACCEPT || c == DO_EDIT )
   {
      if ( !hook_quantifier( dquname, dtype ) )
	 display_error( "Out of memory. Cannot create new quantifier." );
      else if ( c == DO_EDIT )
      {
         changed = 1;
	 main_window();
	 switch( dtype )
	 {
	    case MAPPING:
	       general_mapping_edit( QUANTIFIERS, quantifier_exists( dquname ) );
	       break;
	    case GLB:
	    case INF:
	    case LUB:
	    case SUP:
	       general_induced_by_ordering_edit( QUANTIFIERS, quantifier_exists( dquname ) );
	       break;
	    case INDUCED_BY_OPERATOR:
	       edit_as_induced_by_operator( quantifier_exists( dquname ) );
	       break;
	    default:;
	 }
      }
   }
   main_window();
} /* create_quantifier */

/*
   Name       : create_ordering.
   Function   : create a new ordering.
*/

void create_ordering()
{
   char dordname[ ORDNAMELEN + 1 ] = "";
   int exc, c;
   struct window_borders wb;

   if ( !tvnum )
   {
      confirm( "Truth values have to be defined first.", 1 );
      main_window();
      return;
   }
   prepare_default_window( 13, GENERAL_UPPER_Y, 67, GENERAL_UPPER_Y + 7,
			   " Create ordering ", &wb );
   ( void ) ok_or_cancel( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS );
   focus_on_window( wb );
   gotoxy( 9, 3 );
   cprintf( "Ordering name: " );
   do
   {
      strcpy( dordname, read_in_string( 36, GENERAL_UPPER_Y + 2,
	      OPNAMELEN + 1, 0, BLACK, WHITE, dordname, &exc ) );
      c = ok_or_cancel( 15, GENERAL_UPPER_Y + 5, wb.x2 - wb.x1 - 3,
			!JUST_INIT, OUT, NO_INIT_POS );
      if ( c == DO_ACCEPT || c == DO_EDIT )
      {
	 if ( ( exc = re2( dordname ) ) >= -1 )
	 {
	    add_help( H_E_RE2 );
	    if ( exc == -1 )
	       ( void ) confirm( "Ordering name must not be empty.", 1 );
	    else
	       ( void ) confirm( "Name doesn't match regular expression for ordering name.", 1 );
	    c = -ESC;
	    remove_help();
	 }
	 else if ( ordering_exists( dordname ) )
	 {
	    ( void ) confirm( "Ordering already exists.", 1 );
	    c = -ESC;
	 }
      }
   }
   while ( c <  0 );
   if ( c != DO_CANCEL )
   {
      if ( !hook_ordering( dordname ) )
	 display_error( "Out of memory. Cannot create new ordering." );
      else if ( c == DO_EDIT )
      {
	 changed = 1;
	 main_window();
	 edit_ordering( ordering_exists( dordname ) );
      }
   }

   main_window();
} /* create_ordering */
