/* Includes ********************************************************/
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "adfulo.h"
#include "help.h"
#include "delete.h"


/* Variables ********************************************************/

extern char lgc_name[ LGCNAMELEN + 1 ];

extern char tv[ TVMAX ][ TVNAMELEN + 1 ];
extern int tvnum;
extern int maxlen;

extern struct op_list *op;
extern struct qu_list *qu;
extern struct ord_list *ord;

extern unsigned char changed;

void general_delete( int which )
{
   int c, cc, i = 0, del = -1;
   struct op_list *hop;
   struct qu_list *hqu;
   struct ord_list *hord;
   struct window_borders wb;
   char name[ 15 ], lname[ 25 ], buffer[ 80 ];

   switch( which )
   {
      case OPERATORS:
	 strcpy( name, "operator" );
	 c = how_many_operators();
	 break;
      case QUANTIFIERS:
	 strcpy( name, "quantifier" );
	 c = how_many_quantifiers();
	 break;
      case ORDERINGS:
	 strcpy( name, "ordering" );
	 c = how_many_orderings();
	 break;
      default: return;
   }
   switch( which )
   {
      case OPERATORS:   if ( op == NULL ) i = -1; break;
      case QUANTIFIERS: if ( qu == NULL ) i = -1; break;
      case ORDERINGS:   if ( ord == NULL ) i = -1; break;
      default:;
   }
   if ( i == -1 )
   {
      sprintf( buffer, "No %s defined.", name );
      confirm( buffer, 1 );
      main_window();
      return;
   }
   sprintf( buffer, " Delete %s ", name );
   wb = create_window( 29, GENERAL_UPPER_Y, 51,	GENERAL_UPPER_Y + 9 +
        min( 5, c ), LIGHTGRAY, BLACK, DOUBLE_LINE_BOX,	buffer );
   ( void ) create_window( wb.x1 + 1, wb.y1 + 1, wb.x2 - 1, wb.y1 + 3,
	    LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   ( void ) create_window( wb.x1 + 1, wb.y2 - 3, wb.x2 - 1, wb.y2 - 1,
	    LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, !OUT, NO_INIT_POS, 2, "Delete", "Cancel" );
   do
   {
      c = general_scroll_menu( wb.x1 + 2, GENERAL_UPPER_Y + 4, 5, NO_INIT_POS, BLACK,
	  LIGHTGRAY, SINGLE_LINE_BOX, which );
      if ( c >= 0 )
      {
	 del = c;
	 switch( which )
	 {
	    case OPERATORS:
	       hop = op;
	       for ( i = 0; i < del && hop->next != NULL; i++ ) hop = hop->next;
	       sprintf( lname, "%s/%d", hop->o.opname, hop->o.arity );
	       break;
	    case QUANTIFIERS:
	       hqu = qu;
	       for ( i = 0; i < del && hqu->next != NULL; i++ ) hqu = hqu->next;
	       sprintf( lname, "%s/q", hqu->q.quname );
	       break;
	    case ORDERINGS:
	       hord = ord;
	       for ( i = 0; i < del && hord->next != NULL; i++ ) hord = hord->next;
	       sprintf( lname, "%s/ord", hord->or.ordname );
	       break;
	    default:;
	 }
	 focus_on_window( wb );
	 gotoxy( 3, 3 ); cprintf( "%-15s", lname );
      }
      cc = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	   !JUST_INIT, OUT, NO_INIT_POS, 2, "Delete", "Cancel" );
      switch( cc )
      {
	 case 0:
	    if ( del < 0 )
	    {
	       sprintf( buffer, "No %s selected.", name );
	       ( void ) confirm( buffer, 1 );
		cc = -1;
	    }
	    else
	    {
	       sprintf( buffer, "Delete %s ?", lname );
	       if ( confirm( buffer, 2 ) == DO_OK )
	       {
		  changed = 1;
		  switch( which )
		  {
		     case OPERATORS:
			if ( operator_used( hop->o.opname ) )
			   confirm( "Operator used by induced by operator-quantifier.", 1 );
			else unhook_operator( hop );
			break;
		     case QUANTIFIERS: unhook_quantifier( hqu ); break;
		     case ORDERINGS:
			if ( ordering_used( hord->or.ordname ) )
			   confirm( "Ordering used by induced by ordering-operator or -quantifier.", 1 );
			else unhook_ordering( hord );
		     break;
		     default:;
		  }
	       }
	       else cc = -1;
	    }
	    break;
	 default:;
      }
   }
   while ( cc < 0 );
   main_window();
   return;
}



