/* Includes ********************************************************/
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "adfulo.h"
#include "order.h"
#include "edit.h"
#define XXX 2
#define COMMA 4
#define LBRACE 2
#define RBRACE 3
#define LESS 1
#define TV 0
#define GO_ONE_BACK 5

/* Variables ********************************************************/

extern char lgc_name[ LGCNAMELEN + 1 ];

extern char tv[ TVMAX ][ TVNAMELEN + 1 ];
extern int tvnum;
extern int maxlen;

extern struct op_list *op;
extern struct qu_list *qu;
extern struct ord_list *ord;

extern long dtv;

extern unsigned char changed;

/*
   Name       : display_edit_operator;
   Function   : puts the table stuff on the screen starting with 'pos'-th
		entry.
*/
void display_edit_operator( struct operator op, int pos, int indent,
			    int valbeg )
{
   int i;

   for ( i = 0; ( i + pos ) < op.power && i < SCROLL_WINDOW_LENGTH; i++ )
   {
      gotoxy( indent, i + 1 );
      cprintf( "(%s) ", opstring( op, i + pos ) );
      gotoxy( valbeg - 2, i + 1 );
      cprintf( " %s", strpad( opvalue( *( op.list + i + pos ) ), maxlen ) );
   }
} /* display_edit_operator */

/*
   Name       : display_edit_quantifier;
   Function   : puts the table stuff on the screen starting with 'pos'-th
		entry.
*/
void display_edit_quantifier( struct quantifier op, int pos, int indent,
			      int valbeg, int tupell )
{
   int i;
   char dummy[ 100 ], format[ 20 ];

   if ( pos < 0 || pos >= op.power )
      pos = 0;
   sprintf( format, "%%-%ds", tupell );
   for ( i = 0; ( i + pos ) < op.power && i < SCROLL_WINDOW_LENGTH; i++ )
   {
      gotoxy( indent, i + 1 );
      sprintf( dummy, "{%s}", qustring( op, i + pos ) );
      cprintf( format, dummy );
      gotoxy( valbeg - 2, i + 1 );
      cprintf( " %s", strpad( opvalue( *( op.list + i + pos ) ), maxlen ) );
   }
} /* display_edit_quantifier */

/*
   Name       : compare;
   Function   : returns the index of the first truth value whose "pos"th
		character matches "char", -1 otherwise. If the match is not
		unique, the first matching index + TVMAX is returned.
*/
int compare( char c, int pos )
{
   int i, ret = -1;

   if ( pos >= maxlen )
   {
      display_error( "Function COMPARE: Attention. This position is illegal." );
      return( -1 );
   }
   for ( i = 0; i < tvnum; i++ )
   {
      if ( ( pos < strlen( tv[ i ] ) ) && ( tv[ i ][ pos ] == c ) )
      {
	 if ( ret != -1 ) return( ret + TVMAX );
	 else ret = i;
      }
   }
   return( ret );
} /* compare */

/*
   Name       : highlight.
   Function   : highlights the value of a k-tupel. Bad version, too static.
*/
void highlight( struct operator op, int pos, int scroll_pos, int valbeg )
{
   TATTR( LIGHTGRAY, BLACK );
   gotoxy( valbeg, scroll_pos );
   cprintf( "%s", strpad( opvalue( *( op.list + pos ) ), maxlen ) );
   TATTR( BLACK, LIGHTGRAY );
} /* highlight */

/*
   Name       : normal.
   Function   : dehighlights the value of a k-tupel. Bad version, too static.
*/
void normal( struct operator op, int pos, int scroll_pos, int valbeg )
{

   TATTR( BLACK, LIGHTGRAY );
   gotoxy( valbeg, scroll_pos );
   cprintf( "%s", strpad( opvalue( *( op.list + pos ) ), maxlen ) );
} /* normal */

/*
   Name       : opvalue.
   Function   : returns the truth value of position "pos".
*/

char *opvalue( int pos )
{
   pos -= INITIALIZED;
   if ( pos >= tvnum || pos < 0 ) return( "." );
   return( tv[ pos ] );
}

char *opstring( struct operator op, int pos )
{
   int place[ MAX_ARITY ];
   int ex, i;
   char buffer[ 100 ] = "", dummy[ 20 ];

/*   if ( op.arity == 0 ) return "\0"; */
   ex = (int) pow( (double) tvnum, (double) ( op.arity - 1 ) );
   for ( i = 0; i < MAX_ARITY; i++ ) place[ i ] = 0;
   for ( i = op.arity - 1; i >= 0; i-- )
   {
      place[ i ] = pos / ex;
      pos %=  ex;
      ex /= tvnum;
   }
   strcpy( buffer, ( op.arity > 0 ? tv[ place[ op.arity - 1 ] ] : "\0" ) );
   for ( i = op.arity - 2; i >= 0; i-- )
   {
      strcat( buffer, "," );
      strcat( buffer, strpad( "", 1 + maxlen - strlen( tv[ place[ i + 1 ] ] ) ) );
      strcat( buffer, tv[ place[ i ] ] );
   }
   return( strpad( buffer, ( maxlen + 2 )*op.arity - 2 ) );
}

char *qustring( struct quantifier qu, int pos )
{
   int place[ TVMAX ];
   int ex, i, first;
   static char buffer[ 80 ];
   char dummy[ 20 ];

   ex = ( qu.power + 1 )/2;
   pos = ( qu.power - pos );
   for ( i = 0; i < TVMAX; i++ ) place[ i ] = 0;
   for ( i = tvnum - 1; i >= 0; i-- )
   {
      place[ i ] = ( ( ex & pos ) == ex );
      ex >>= 1;
   }
   strcpy( buffer, "" );
   first = 1;
   for ( i = 0; i < tvnum; i++ )
   {
      if ( place[ tvnum - 1 - i ] )
      {
	 if ( first )
	 {
	    strcat( buffer, tv[ i ] );
	    first = 0;
	 }
	 else
	 {
	    strcpy( dummy, ", " );
	    strcat( buffer, dummy );
	    strcat( buffer, tv[ i ] );
	 }
      }
   }
   return( buffer );
} /* qustring */

/*
   Name       : menu_while_editing.
   Function   : paste the options menu for editing on the screen and
		wait for option to be chosen. Return the index of this
		option.
*/

int menu_while_editing()
{
   int d;

   save_screen();
   (void) create_window( 22, 21, 59, 23, LIGHTGRAY, BLACK, DOUBLE_LINE_BOX, 0 );
   d = horizontal_select_menu( 23, 22, 36, !JUST_INIT, !OUT, NO_INIT_POS, 2,
       "Accept", "Cancel" );
   restore_screen();
   return( d );
} /* menu_while_editing */

/*
   Name       : display_edit_table.
   Function   : displays the table entries of a binary operator.
*/

void display_edit_table( struct operator op, struct window_borders wb,
			 int ftv, int lx, int ly )
{
   int i, j;

   focus_on_window( wb );
   for ( i = 0; i < lx; i++ )
      for ( j = 0; j < ly; j++ )
      {
	 gotoxy( 1 + i*( maxlen + XXX ), 1 + j*2 );
	 cprintf( "%s", strpad( opvalue( *( op.list + i + tvnum*j + ftv ) ),
		  maxlen ) );
      }
} /* display_edit_table */

/*
   Name       : display_vert.
   Function   : displays the vertical value strip at table editing.
*/

void display_vert( struct window_borders wb, int ftv, int ly,
		   struct window_borders ret )
{
   int i;

   focus_on_window( wb );
   for ( i = ftv; i < tvnum && ( i - ftv ) < ly; i++ )
      OUTXY( 1, ( i - ftv )*2 + 1, strpad( tv[ i ], maxlen ) );
   focus_on_window( ret );
} /* display_vert */

/*
   Name       : display_hor.
   Function   : displays the horizontal value strip at table editin.
*/

void display_hor( struct window_borders wb, int ftv, int lx,
		   struct window_borders ret )
{
   int i;

   focus_on_window( wb );
   for ( i = ftv; i < tvnum && ( i - ftv ) < lx; i++ )
   {
      gotoxy( 1 + ( i - ftv )*( maxlen + XXX ), 1 );
      cprintf( "%s", strpad( tv[ i ], maxlen ) );
   }
   focus_on_window( ret );
} /* display_hor */

/*
   Name       : edit_operator_as_table.
   Function   : Guess.... ;-P.
*/

void edit_operator_as_table( struct operator *op )
{
   int c, i, j;
   struct window_borders vert, hor, field;
   int lx, ly;
   int pos = 0, spx = 1, spy = 1;
   int lowery = 23; /* Constant for this function only */
   char dummy[ 80 ];
   char *backup;
   int indent;

   backup = (char *)malloc( sizeof( char )*op->power );
   if ( backup == NULL )
   {
      i = confirm( "Too low on memory. <Cancel> will not undo changes. Continue anyway? ",
      2 );
      main_window();
      if ( i == 1 ) return;
   }
   if ( backup != NULL ) strcpy( backup, op->list );
   indent = max( ( MAIN_WINDOW_WIDTH - ( maxlen + XXX )*( tvnum + 1 ) - 1 )/2, 0 );
   ly = min( ( lowery - 5 )/2, tvnum );
   vert = create_window( indent + 2, 5, indent + 2 + maxlen, 4 + 2*ly,
			 BLACK, LIGHTGRAY, NO_BOX, 0 );
   hor = create_window( indent + 4 + maxlen, 3, 79, 3, BLACK, LIGHTGRAY, NO_BOX, 0 );
   field = create_window( indent + maxlen + 4, 5, 79, 4 + ly*2,
			  BLACK, LIGHTGRAY, NO_BOX, 0 );
   lx = min ( ( hor.x2 - hor.x1 )/( maxlen + XXX ), tvnum );
   main_window();
   for ( c = 2; c <= ly + 1; c ++ )
      for ( i = min( 78, ( maxlen + XXX )*( lx + 1 ) + 1 ); i >= 1; i-- )
	 OUTXY( indent + i, c*2, "" );
   for ( i = 1; i <= lx; i++ )
      for ( c = 1; c <= ly*2 + 2; c++ )
      {
	 gotoxy( indent + maxlen + 2 + i*( maxlen + XXX ), c );
	 cprintf( "%c", ( c % 2 ? '' : '' ) );
      }
   for ( i = 1; i <= 1 + min( 78, ( lx + 1 )*( maxlen + XXX ) ); i++ )
      OUTXY( indent + i, 2, "" );
   sprintf( dummy, "%s/%d", op->opname, op->arity );
   if ( ( j = vert.x2 - strlen( dummy ) - 1 ) <= 0 ) j = 1;
   OUTXY( j, 1, dummy );
   for ( i = 1; i <= ly*2 + 2; i++ ) OUTXY( indent + maxlen + 2, i, "" );
   OUTXY( indent + maxlen + 2, 2, "" );
   display_vert( vert, pos/tvnum - spy + 1, ly, field );
   display_hor( hor, pos - spx + 1, lx, field );
   display_edit_table( *op, field, pos - ( spx - 1) + ( spy - 1 )*tvnum, lx, ly );
   do
   {
      inverse( ( spx - 1 )*( maxlen + XXX ) + 1, 1 + ( spy - 1 )*2,
	       strpad( opvalue( *( op->list + pos ) ), maxlen ), LIGHTGRAY*16 );
      cursor( 0 );
      c = get_key();
      cursor( 1 );
      inverse( ( spx - 1 )*( maxlen + XXX ) + 1, 1 + ( spy - 1 )*2,
	       strpad( opvalue( *( op->list + pos ) ), maxlen ), LIGHTGRAY );
      switch( c )
      {
	 case UP:
	    if ( spy > 1 )
	    {
	       spy -= 1;
	       pos -= tvnum;
	    }
	    else if ( pos >= tvnum )
	    {
	       pos -= tvnum;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_vert( vert, pos/tvnum - spy + 1, ly, field );
	    }
	    break;
	 case LEFT:
	    if ( spx > 1 )
	    {
	       spx -= 1;
	       pos -= 1;
	    }
	    else if ( pos % tvnum != 0 )
	    {
	       pos -= 1;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_hor( hor, pos%tvnum - spx + 1, lx, field );
	    }
	    break;
	 case DOWN:
	    if ( spy < ly )
	    {
	       spy += 1;
	       pos += tvnum;
	    }
	    else if ( pos < ( op->power - tvnum ) )
	    {
	       pos += tvnum;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_vert( vert, pos/tvnum - spy + 1, ly, field );
	    }
	    break;
	 case RIGHT:
	    if ( spx < lx )
	    {
	       spx += 1;
	       pos += 1;
	    }
	    else if ( pos % tvnum != tvnum - 1 )
	    {
	       pos += 1;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_hor( hor, pos%tvnum - spx + 1, lx, field );
	    }
	    break;
	 case POS1:
	    if ( spx != 1 || spy != 1 )
	    {
	       pos -= ( ( spx - 1 ) + ( spy - 1 )*tvnum );
	       spx = 1;
	       spy = 1;
	    }
	    else if ( pos != 0 )
	    {
	       pos = 0;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_hor( hor, pos%tvnum - spx + 1, lx, field );
	       display_vert( vert, pos/tvnum - spy + 1, ly, field );
	    }
	    break;
	 case END :
	    if ( spx != 1 || spy != ly )
	    {
	       pos -= ( ( spx - 1 ) - ( ly - spy )*tvnum );
	       spx = 1;
	       spy = ly;
	    }
	    else if ( pos != op->power - tvnum )
	    {
	       pos = op->power - tvnum;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_hor( hor, pos%tvnum - spx + 1, lx, field );
	       display_vert( vert, pos/tvnum - spy + 1, ly, field );
	    }
	    break;
	 case PGUP:
	    if ( spx != lx || spy != 1 )
	    {
	       pos += ( lx - spx ) - ( spy - 1 )*tvnum;
	       spx = lx;
	       spy = 1;
	    }
	    else if ( pos != tvnum - 1 )
	    {
	       pos = tvnum - 1;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_hor( hor, pos%tvnum - spx + 1, lx, field );
	       display_vert( vert, pos/tvnum - spy + 1, ly, field );
	    }
	    break;
	 case PGDOWN:
	    if ( spx != lx || spy != ly )
	    {
	       pos += ( lx - spx ) + ( ly - spy )*tvnum;
	       spx = lx;
	       spy = ly;
	    }
	    else if ( pos != op->power -1 )
	    {
	       pos = op->power - 1;
	       display_edit_table( *op, field, pos - ( spx - 1 ) - ( spy - 1 )*tvnum, lx, ly );
	       display_hor( hor, pos%tvnum - spx + 1, lx, field );
	       display_vert( vert, pos/tvnum - spy + 1, ly, field );
	    }
	    break;
	 case ESC:
	 case RETURN:
	    switch( menu_while_editing() )
	    {
	       case DO_CANCEL:
		  if ( backup != NULL )
		  {
		     strcpy( op->list, backup );
		     free( backup );
		  }
	       case DO_ACCEPT:
		  changed = 1;
		  main_window();
		  return;
	    }
	    focus_on_window( field );
	    break;
	 default:
	    if ( ( j = compare( c, 0 ) ) != -1 )
	    {
	       if ( j < TVMAX )
	       {
		  *( op->list + pos ) = INITIALIZED + j;
		  inverse( ( spx - 1 )*( maxlen + XXX ) + 1, 1 + ( spy - 1 )*2,
			   strpad( opvalue( *( op->list + pos ) ), maxlen ), LIGHTGRAY*16 + BLACK );
	       }
	       else
	       {
		  save_screen();
		  if ( ( i = general_scroll_menu( 2, 3, min( tvnum, 10 ),
		     j - TVMAX, LIGHTGRAY, BLACK, SINGLE_LINE_BOX, TRUTH_VALUES ) ) >= 0
		     && i < tvnum )
		  {
		     *( op->list + pos ) = INITIALIZED + i;
		     focus_on_window( field );
		     inverse( ( spx - 1 )*( maxlen + XXX ) + 1, 1 + ( spy - 1 )*2,
			      strpad( opvalue( *( op->list + pos ) ), maxlen ), LIGHTGRAY*16 + BLACK );

		  }
		  else focus_on_window( field );
		  restore_screen();
	       }
	    }
	 }
   }
   while ( 1 );
} /* edit_operator_as_table */


/*
   Name       : general_mapping_edit.
   Function   : edit a mapping operator or a quantifier.
*/

void general_mapping_edit( int which, void *op )
{
   int c, j;
   int i, position, scroll_position, pwr;
   char dummy[ 80 ];
   char *backup;
   int indent, valbeg, tupell = 0;
   struct window_borders wb;
   struct operator *opp;
   struct quantifier *quu;

   switch( which ) {
      case OPERATORS: opp = (struct operator *)op;
	 pwr = opp->power; break;
      case QUANTIFIERS: quu = (struct quantifier *)op;
	 pwr = quu->power; break;
      default: return;
   }
   main_window();
   backup = (char *)malloc( sizeof( char )*pwr );
   if ( backup == NULL )
   {
      i = confirm( "Too low on memory. <Cancel> will not undo changes. Continue anyway? ",
	  2 );
      main_window();
      if ( i == 1 ) return;
   }
   switch( which ) {
      case OPERATORS:
	 if ( backup != NULL ) strcpy( backup, opp->list );
	 tupell = max( ( maxlen + 2 ) * opp->arity, 2);
	 break;
      case QUANTIFIERS:
	 if ( backup != NULL ) strcpy( backup, quu->list );
	 for ( i = 0; i < tvnum; i++ ) tupell += strlen( tv[ i ] );
	 tupell += ( tvnum*2 );
	 break;
   }
   indent = ( MAIN_WINDOW_WIDTH - ( tupell + 3 + maxlen ) ) / 2;
   valbeg = tupell + 3 + indent;
   TATTR( BLACK, LIGHTGRAY );
   switch( which ) {
      case OPERATORS: sprintf( dummy, "%s/%d", opp->opname, opp->arity ); break;
      case QUANTIFIERS: sprintf( dummy, "%s/q", quu->quname ); break;
   }
   if ( strlen( dummy ) > tupell )
      j =  indent - strlen( dummy ) + tupell;
   else j = indent;
   gotoxy( j, 1 );
   cprintf( "%s", strpad( dummy, tupell ) );
   OUTXY( valbeg - 2, 1, " value" );
   gotoxy( j, 2 );
   for ( i = j; i < 79 && i < valbeg + max( 6, maxlen + 1 ); i++ )
      cprintf( "" );
   gotoxy( valbeg - 2, 2 );
   cprintf( "" );
   wb = create_window( 2, 5, 79, 23, BLACK, LIGHTGRAY, NO_BOX, 0 );
   TATTR( BLACK, LIGHTGRAY );
   switch( which ) {
      case OPERATORS: display_edit_operator( *opp, 0, indent, valbeg ); break;
      case QUANTIFIERS: display_edit_quantifier( *quu, 0, indent, valbeg, tupell ); break;
   }
   scroll_position = 1;
   position = 0;
   do
   {
      switch( which ) {
	 case OPERATORS:
	    inverse( valbeg, scroll_position,
		     strpad( opvalue( *( opp->list + position ) ), maxlen ),
		     LIGHTGRAY*16 );
	    break;
	 case QUANTIFIERS:
	    inverse( valbeg, scroll_position,
		     strpad( opvalue( *( quu->list + position ) ), maxlen ),
		     LIGHTGRAY*16 );
	    break;
      }
      cursor( 0 );
      c = get_key();
      cursor( 1 );
      switch( which ) {
	 case OPERATORS:
	    inverse( valbeg, scroll_position,
		     strpad( opvalue( *( opp->list + position ) ), maxlen ),
		     LIGHTGRAY );
	    break;
	 case QUANTIFIERS:
	    inverse( valbeg, scroll_position,
		     strpad( opvalue( *( quu->list + position ) ), maxlen ),
		     LIGHTGRAY );
	    break;
      }
      switch( c ) {
      case UP:
	 if ( scroll_position == 1 )
	 {
	    if ( position > 0 )
	    {
	       position -= 1;
	       gotoxy( indent, 1 );
	       insline();
	       switch( which ) {
		  case OPERATORS:
		     cprintf( "(%s) ", opstring( *opp, position ) );
		     gotoxy( valbeg - 2, 1 );
		     cprintf( " %s", strpad( opvalue( *( opp->list + position ) ),
			      maxlen ) );
		     break;
		  case QUANTIFIERS:
		     cprintf( "{%s} ", qustring( *quu, position ) );
		     gotoxy( valbeg - 2, 1 );
		     cprintf( " %s", strpad( opvalue( *( quu->list + position ) ),
			      maxlen ) );
		     break;
	       }
	    }
	 }
	 else
	 {
	    position -= 1;
	    scroll_position -= 1;
	 }
	 break;
      case DOWN:
	 if ( scroll_position >= SCROLL_WINDOW_LENGTH )
	 {
	    if ( position < ( pwr - 1 ) )
	    {
	       position += 1;
	       cprintf( "\n" );
	       gotoxy( indent, SCROLL_WINDOW_LENGTH );
	       switch( which ) {
		  case OPERATORS:
		     cprintf( "(%s) ", opstring( *opp, position ) );
		     gotoxy( valbeg - 2, SCROLL_WINDOW_LENGTH );
		     cprintf( " %s", strpad( opvalue( *( opp->list + position ) ),
			      maxlen ) );
		     break;
		  case QUANTIFIERS:
		     cprintf( "{%s} ", qustring( *quu, position ) );
		     gotoxy( valbeg - 2, SCROLL_WINDOW_LENGTH );
		     cprintf( " %s", strpad( opvalue( *( quu->list + position ) ),
			      maxlen ) );
		     break;
	       }
	    }
	 }
	 else if ( position < ( pwr - 1 ) )
	 {
	    position += 1;
	    scroll_position += 1;
	 }
	 break;
      case PGUP :
	 if ( scroll_position > 1 )
	 {
	    position -= ( scroll_position - 1 );
	    scroll_position = 1;
	 }
	 else
	 {
	    if ( position != 0 )
	    {
	       if ( ( position -= SCROLL_WINDOW_LENGTH ) < 0 ) position = 0;
	       switch( which ) {
		  case OPERATORS: display_edit_operator( *opp, position, indent, valbeg ); break;
		  case QUANTIFIERS: display_edit_quantifier( *quu, position, indent, valbeg, tupell ); break;
	       }
	    }
	 }
	 break;
      case PGDOWN :
	 if ( scroll_position < SCROLL_WINDOW_LENGTH && scroll_position < pwr )
	 {
	    if ( SCROLL_WINDOW_LENGTH > pwr )
	    {
	       scroll_position = pwr;
	       position = pwr - 1;
	    }
	    else
	    {
	       position += ( SCROLL_WINDOW_LENGTH - scroll_position );
	       scroll_position = SCROLL_WINDOW_LENGTH;
	    }
	 }
	 else
	 {
	    if ( position != pwr - 1 )
	    {
	       if ( ( position += SCROLL_WINDOW_LENGTH ) >= pwr )
		  position = pwr - 1;
	       switch( which ) {
		  case OPERATORS: display_edit_operator( *opp, position - scroll_position + 1, indent, valbeg ); break;
		  case QUANTIFIERS: display_edit_quantifier( *quu, position - scroll_position + 1, indent, valbeg, tupell ); break;
	       }
	    }
	 }
	 break;
      case POS1:
	 scroll_position = 1;
	 if ( position != 0 )
	 {
	    position = 0;
	    switch( which ) {
	       case OPERATORS: display_edit_operator( *opp, position, indent, valbeg ); break;
	       case QUANTIFIERS: display_edit_quantifier( *quu, position, indent, valbeg, tupell ); break;
	    }
	 }
	 break;
      case END:
	 if ( ( scroll_position = SCROLL_WINDOW_LENGTH ) > pwr )
	    scroll_position = pwr;
	 if ( position != pwr - 1 )
	 {
	    position = pwr - 1;
	    switch( which ) {
	       case OPERATORS: display_edit_operator( *opp, position - scroll_position + 1, indent, valbeg ); break;
	       case QUANTIFIERS: display_edit_quantifier( *quu, position - scroll_position + 1, indent, valbeg, tupell ); break;
	    }
	 }
	 break;
      case ESC:
      case RETURN:
	 switch( menu_while_editing() )
	 {
	    case DO_CANCEL:
	       switch( which ) {
		  case OPERATORS:
		     if ( backup != NULL )
		     {
			strcpy( opp->list, backup );
			free( backup );
		     }
		     break;
		  case QUANTIFIERS:
		     if ( backup != NULL )
		     {
			strcpy( quu->list, backup );
			free( backup );
		     }
		     break;
	       }
	    case DO_ACCEPT:
	       changed = 1;
	       main_window();
	       clrscr();
	       return;
	 }
	 focus_on_window( wb );
	 break;
      default:
	 if ( ( j = compare( c, 0 ) ) != -1 )
	 {
	    if ( j < TVMAX )
	    {
	       switch( which ) {
		 case OPERATORS:
		    *( opp->list + position ) = INITIALIZED + j;
		    inverse( valbeg, scroll_position,
			     strpad( opvalue( *( opp->list + position ) ), maxlen ), LIGHTGRAY*16 );
		    break;
		 case QUANTIFIERS:
		    *( quu->list + position ) = INITIALIZED + j;
		    inverse( valbeg, scroll_position,
			     strpad( opvalue( *( quu->list + position ) ), maxlen ), LIGHTGRAY*16 );
		    break;
	       }
	    }
	    else
	    {
	       save_screen();
		  if ( ( i = general_scroll_menu( 2, 3, min( tvnum, 10 ),
		     j - TVMAX, LIGHTGRAY, BLACK, SINGLE_LINE_BOX, TRUTH_VALUES ) ) >= 0
		     && i < tvnum )
	       {
                  focus_on_window( wb );
		  switch( which ) {
		     case OPERATORS:
			*( opp->list + position ) = INITIALIZED + i;
			inverse( valbeg, scroll_position,
				 strpad( opvalue( *( opp->list + position ) ), maxlen ), LIGHTGRAY*16 );
			break;
		     case QUANTIFIERS:
			*( quu->list + position ) = INITIALIZED + i;
			inverse( valbeg, scroll_position,
				 strpad( opvalue( *( quu->list + position ) ), maxlen ), LIGHTGRAY*16 );
			break;
		  }
	       }
	       else focus_on_window( wb );
	       restore_screen();
	    }
	 }
      }
   }
   while ( 1 );
} /* edit_operator_as_mapping */

void general_choose( int which )
{
   int c, cc, i = 0, edit = -1;
   struct op_list *hop;
   struct qu_list *hqu;
   struct ord_list *hord;
   struct window_borders wb;
   char name[ 15 ], lname[ 25 ], buffer[ 80 ];

   switch( which )
   {
      case OPERATORS:
	 strcpy( name, "operator" );
	 c = how_many_operators();
	 break;
      case QUANTIFIERS:
	 strcpy( name, "quantifier" );
	 c = how_many_quantifiers();
	 break;
      case ORDERINGS:
	 strcpy( name, "ordering" );
	 c = how_many_orderings();
	 break;
      default: return;
   }
   switch( which )
   {
      case OPERATORS:   if ( op == NULL ) i = -1; break;
      case QUANTIFIERS: if ( qu == NULL ) i = -1; break;
      case ORDERINGS:   if ( ord == NULL ) i = -1; break;
      default:;
   }
   if ( i == -1 )
   {
      sprintf( buffer, "No %s defined.", name );
      confirm( buffer, 1 );
      main_window();
      return;
   }
   sprintf( buffer, " Choose %s ", name );
   wb = create_window( 29, GENERAL_UPPER_Y, 51, GENERAL_UPPER_Y + 9 +
        min( 5, c ), LIGHTGRAY, BLACK, DOUBLE_LINE_BOX,	buffer );
   ( void ) create_window( wb.x1 + 1, wb.y1 + 1, wb.x2 - 1, wb.y1 + 3,
	    LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   ( void ) create_window( wb.x1 + 1, wb.y2 - 3, wb.x2 - 1, wb.y2 - 1,
	    LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, !OUT, NO_INIT_POS, 2, "Edit", "Cancel" );
   do
   {
      c = general_scroll_menu( wb.x1 + 2, GENERAL_UPPER_Y + 4, 5, NO_INIT_POS, BLACK,
	  LIGHTGRAY, SINGLE_LINE_BOX, which );
      if ( c >= 0 )
      {
	 edit = c;
	 switch( which )
	 {
	    case OPERATORS:
	       hop = op;
	       for ( i = 0; i < edit && hop->next != NULL; i++ ) hop = hop->next;
	       sprintf( lname, "%s/%d", hop->o.opname, hop->o.arity );
	       break;
	    case QUANTIFIERS:
	       hqu = qu;
	       for ( i = 0; i < edit && hqu->next != NULL; i++ ) hqu = hqu->next;
	       sprintf( lname, "%s/q", hqu->q.quname );
	       break;
	    case ORDERINGS:
	       hord = ord;
	       for ( i = 0; i < edit && hord->next != NULL; i++ ) hord = hord->next;
	       sprintf( lname, "%s/ord", hord->or.ordname );
	       break;
	    default:;
	 }
	 focus_on_window( wb );
	 gotoxy( 3, 3 ); cprintf( "%-15s", lname );
      }
      cc = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	   !JUST_INIT, OUT, NO_INIT_POS, 2, "Edit", "Cancel" );
      switch( cc )
      {
	 case 0:
	    if ( edit < 0 )
	    {
	       sprintf( buffer, "No %s selected.", name );
	       ( void ) confirm( buffer, 1 );
		cc = -1;
	    }
	    else
	    {
	       main_window();
	       switch( which )
	       {
		  case OPERATORS:
		     switch( hop->o.typ )
		     {
			case MAPPING:
			   general_mapping_edit( OPERATORS, &hop->o ); break;
			case TABLE:
			   edit_operator_as_table( &hop->o ); break;
			case GLB:
			case INF:
			case LUB:
			case SUP:
			   general_induced_by_ordering_edit( OPERATORS,
			   &hop->o );
			   break;
			default: display_error( "Illegal type for operator." );
			   main_window();
			   break;
		     }
		     break;
		  case QUANTIFIERS:
		     switch( hqu->q.typ )
		     {
			case MAPPING:
			   general_mapping_edit( QUANTIFIERS, &hqu->q ); break;
			case GLB:
			case INF:
			case LUB:
			case SUP:
			   general_induced_by_ordering_edit( QUANTIFIERS,
			   &hqu->q );
			   break;
			case INDUCED_BY_OPERATOR:
			   edit_as_induced_by_operator( &hqu->q );
			   break;
			default: display_error( "Illegal type for quantifier." );
			   main_window();
			   break;
		     }
		     break;
		  case ORDERINGS:
		     edit_ordering( &hord->or );
		      break;
		  default:;
	       }
	    }
	    break;
	 default:;
      }
   }
   while ( cc < 0 );
   main_window();
}

void general_induced_by_ordering_edit( int which, void *h )
{
   struct operator *hop;
   struct quantifier *hqu;
   struct ord_list *hord;
   struct window_borders wb;
   char dummy[ 20 ], buffer[ 80 ], dordname[ ORDNAMELEN + 1 ];
   int which_part = 0, dtyp;
   int i, c, cc, ccc;

   switch( which )
   {
      case OPERATORS:
	 strcpy( dummy, "operator" );
	 hop = (struct operator *)h;
	 dtyp = hop->typ;
	 strcpy( dordname, hop->ordname );
	 break;
      case QUANTIFIERS:
	 strcpy( dummy, "quantifier" );
	 hqu = (struct quantifier *)h;
	 dtyp = hqu->typ;
	 strcpy( dordname, hqu->oporord );
	 break;
      default: return;
   }
   sprintf( buffer, " Edit induced by ordering-%s ", dummy );
   prepare_default_window( 13, GENERAL_UPPER_Y, 68, GENERAL_UPPER_Y + 11,
			   buffer, &wb );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   focus_on_window( wb );
   gotoxy( 7, 3 );
   dummy[ 0 ] -= 32;
   switch( which )
   {
      case OPERATORS:
	 cprintf( "%9s name: %s/%d", dummy, hop->opname, hop->arity );
	 break;
      case QUANTIFIERS:
	 cprintf( "%9s name: %s/q", dummy, hqu->quname );
	 break;
      default:;
   }
   gotoxy( 7, 5 );
   cprintf( "     induced by: %s", type2str( dtyp ) );
   gotoxy( 7, 7 );
   cprintf( "       Ordering: %s", strlen( dordname ) ? dordname : "." );
   which_part = 0;
   do
   {
      c = -ESC;
      do
      {
	 switch( which_part )
	 {
	    case 0:
	       inverse( 24, 5, type2str( dtyp ), LIGHTGRAY );
	       cursor( 0 );
	       cc = get_key();
	       cursor( 1 );
	       inverse( 24, 5, type2str( dtyp ), LIGHTGRAY*16 );
	       switch( cc )
	       {
		  case RETURN:
		     save_screen();
		     ccc = general_scroll_menu( 2, 3, 4, NO_INIT_POS,
			   LIGHTGRAY, BLACK, SINGLE_LINE_BOX, BIN_OPS );
		     restore_screen();
		     focus_on_window( wb );
		     if ( ccc >= 0 )
		     {
			dtyp = ccc + GLB;
			gotoxy( 24, 5 );
			cprintf( "%s", type2str( dtyp ) );
		     }
		     break;
		  case ESC:
		  case SHIFT_TAB:
		  case UP:
		  case LEFT: which_part = 2; break;
		  case TAB:
		  case DOWN:
		  case RIGHT: which_part = 1; break;
		  default:;
	       }
	       break;
	    case 1:
	       inverse( 24, 7, strlen( dordname ) ? dordname : ".", LIGHTGRAY );
	       cursor( 0 );
	       cc = get_key();
	       cursor( 1 );
	       inverse( 24, 7, strlen( dordname ) ? dordname : ".", LIGHTGRAY*16 );
	       switch( cc )
	       {
		  case RETURN:
		     if ( !ord )
		     {
			confirm( "No orderings defined.", 1 );
			focus_on_window( wb );
		     }
		     else
		     {
			save_screen();
			ccc = general_scroll_menu( 2, 3, 4, NO_INIT_POS,
			      LIGHTGRAY, BLACK, SINGLE_LINE_BOX, ORDERINGS );
			restore_screen();
			focus_on_window( wb );
			if ( ccc >= 0 )
			{
			   hord = ord;
                           for ( i = 0; i < ccc; i++ ) hord = hord->next;
			   strcpy( dordname, hord->or.ordname );
			   gotoxy( 24, 7 );
			   cprintf( "%s", strlen( dordname ) ? dordname : "." );
			}
		     }
		     break;
		  case ESC:
		  case TAB:
		  case DOWN:
		  case RIGHT: which_part = 2; break;
		  case SHIFT_TAB:
		  case UP:
		  case LEFT: which_part = 0; break;
		  default:;
	       }
	       break;
	    case 2:
	       c =  horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
		    !JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );

	       focus_on_window( wb );
	       switch( c )
	       {
		  case -ESC:
		  case -TAB:
		  case -RIGHT:
		  case -DOWN:
		  case DO_EDIT: which_part = 0; break;
		  case -SHIFT_TAB:
		  case -UP:
		  case -LEFT: which_part = 1; break;
	       }
	       break;
	    default:;
	 }
      }
      while ( c < 0 );
      if ( c == DO_ACCEPT )
      {
	 changed = 1;
	 switch( which )
	 {
	    case OPERATORS:
	       hop->typ = dtyp;
	       strcpy( hop->ordname, dordname );
	       break;
	    case QUANTIFIERS:
	       hqu->typ = dtyp;
	       strcpy( hqu->oporord, dordname );
	       break;
	    default:;
	 }
      }
   }
   while ( c == -ESC );
   main_window();
} /* general_induced_by_ordering_edit */

void edit_as_induced_by_operator( struct quantifier *hqu )
{
   struct op_list *hop;
   struct window_borders wb;
   char dummy[ 20 ], dopname[ OPNAMELEN + 1 ];
   int i, c, cc, ccc, darity;

   prepare_default_window( 13, GENERAL_UPPER_Y, 68, GENERAL_UPPER_Y + 9,
			   " Edit induced by operator-quantifier ", &wb );
   gotoxy( 3, 3 );
   cprintf( "    Quantifier name: %s/q", hqu->quname );
   strcpy( dopname, hqu->oporord );
   darity = hqu->arity;
   gotoxy( 3, 5 );
   if ( strlen( dopname ) != 0 )
      sprintf( dummy, "%s/%d", dopname, darity );
   else
      sprintf( dummy, "./." );
   cprintf( "induced by operator: %s", dummy );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   focus_on_window( wb );
   c = -ESC;
   do
   {
      inverse( 24, 5, dummy, LIGHTGRAY );
      cursor( 0 );
      c = get_key();
      cursor( 1 );
      inverse( 24, 5, dummy, LIGHTGRAY*16 );
      switch( c )
      {
	 case RETURN:
	    if ( !op )
	    {
	       confirm( "No operators defined.", 1 );
	       focus_on_window( wb );
	    }
	    else
	    {
	       save_screen();
	       ccc = general_scroll_menu( 2, 3, 4, NO_INIT_POS,
		     LIGHTGRAY, BLACK, SINGLE_LINE_BOX, OPERATORS );
	       restore_screen();
	       focus_on_window( wb );
	       if ( ccc >= 0 )
	       {
		  hop = op;
		  for ( i = 0; i < ccc; i++ ) hop = hop->next;
		  if ( hop->o.arity < 2 )
		  {
		     confirm( "Operator's arity must be larger than 1.", 1 );
		     focus_on_window( wb );
		  }
		  else
		  {
		     strcpy( dopname, hop->o.opname );
		     darity = hop->o.arity;
		     sprintf( dummy, "%s/%d", dopname, darity );
		     gotoxy( 24, 5 );
		     cprintf( "%s", dummy );
		  }
	       }
	    }
	    c = -ESC;
	    break;
	 default:
	    c = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
		!JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
	    focus_on_window( wb );
	    break;
      }
   }
   while ( c < 0 );
   if ( c == DO_ACCEPT )
   {
      changed = 1;
      strcpy( hqu->oporord, dopname );
      hqu->arity = darity;
   }
   main_window();
} /* edit_as_induced_operator */

/*
   Name       : edit_designated_truth_values.
   Function   : self explaining, I hope.
*/

void edit_designated_truth_values()
{
   char **str;
   char dummy[ TVNAMELEN + 4 ];
   struct window_borders wb, dis;
   int yes[ TVMAX ];
   int i, j, c, d;
   long ex, dtvbackup;

   if ( tvnum == 0 )
   {
      confirm( "Truth values have to be specified first.", 1 );
      main_window();
      return;
   }
   dtvbackup = dtv;
   ex = 1;
   for ( i = 0; i < tvnum; i++ )
   {
      yes[ i ] = ( ex & dtv ) == ex;
      ex <<= 1;
   }
   str = (char **)malloc( sizeof( char * ) * tvnum );
   if ( str == NULL )
   {
      display_error( "Out of memory. Cannot create table." );
      return;
   }
   for ( i = 0; i < tvnum; i++ )
   {
      str[ i ] = (char *)malloc( sizeof( char ) * ( strlen( tv[ i ] ) + 4 ) );
      if ( str[ i ] == NULL )
      {
	 display_error( "Out of memory. Cannot create table." );
	 return;
      }
      sprintf( dummy, "(%c)%s", ( yes[ i ] ? '*' : ' ' ), tv[ i ] );
      strcpy( str[ i ], dummy );
   }
   i = ( maxlen + 4 )*( tvnum >= 3 ? 3 : tvnum );
   j = i/2;
   prepare_default_window( 37 - max( j, 15 ), GENERAL_UPPER_Y, 43 + max( j, 15 ),
		       GENERAL_UPPER_Y + tvnum/3 + !!( tvnum%3 ) + 6,
		       " Edit designated truth values ", &wb );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   dis = create_window( 40 - j, GENERAL_UPPER_Y + 1, 40 + j + !!( i%2 ),
			GENERAL_UPPER_Y + tvnum/3 + !!(tvnum%3) + 2,
			LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   for ( i = 0; i < tvnum/3 + !!( tvnum%3 ); i++ )
      for ( j = 0; j < 3 && j + 3*i < tvnum; j++ )
	 OUTXY( j*( maxlen + 4 ) + 2, i + 2, str[ i*3 + j ] );
   i = 0;
   j = 0;
   do
   {
      do
      {
	 inverse( i*( maxlen + 4 ) + 2, j + 2, str[ i + 3*j ], LIGHTGRAY );
	 cursor( 0 );
	 c = get_key();
         cursor( 1 );
	 inverse( i*( maxlen + 4 ) + 2, j + 2, str[ i + 3*j ], LIGHTGRAY*16 );
	 switch( c )
	{
	     case UP:
	       if ( j > 0 ) j -= 1; break;
	    case DOWN:
	       if ( j*3 + i + 3 < tvnum ) j += 1;
	       else c = ESC; break;
	    case RIGHT:
	       if ( i < 2 && j*3 + i + 1 < tvnum ) i += 1;
	       else if ( i == 2 && ( j + 1 )*3 < tvnum )
	       {
		  i = 0;
		  j += 1;
	       }
	       break;
	    case LEFT:
	       if ( i > 0 ) i -= 1;
	       else if ( j > 0 )
	       {
		  j -= 1;
		  i = 2;
	       }
	       break;
	    case PGUP : j = 0; break;
	    case PGDOWN: j = tvnum/3;
	       if ( j*3 + i >= tvnum ) j -= 1;
	       break;
	    case RETURN:
	       d = i + 3*j;
	       if ( *( str[ d ] + 1 ) == ' ' )
		  *( str[ d ] + 1 ) = '*';
	       else *( str[ d ] + 1 ) = ' ';
	       yes[ d ] = !yes[ d ];
	       break;
	 }
      }
      while ( c != ESC );
      focus_on_window( wb );
      c = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	  !JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
      if ( c < 0 ) c = -ESC;
      focus_on_window( dis );
   }
   while ( c == -ESC );
   if ( c == DO_CANCEL )
      dtv = dtvbackup;
   else if ( c == DO_ACCEPT )
   {
      changed = 1;
      ex = 1;
      dtv = 0;
      for ( i = 0; i < tvnum; i++ )
      {
	 if ( yes[ i ] ) dtv += ex;
	 ex <<= 1;
      }
   }
   for ( i = 0; i < tvnum; i++ ) free( str[ i ] );
   free( str );
   main_window();
} /* edit_designated_truth_values */

/*
   Name       : ord2str.
   Function   : converts the coded ordering string to a string that really
		is to be printed ( to output file/stdout. )
*/

void ord2str( char *str, char *l, int width )
{
  int i, j = 0;
  char dummy[ TVNAMELEN + 1 ], c;

  strcpy( l, "\0" );
  for ( i = 0; i < strlen( str ) && i < ORDERLEN; i++ )
  {
     c = *( str + i );
     switch( c )
     {
	case '{':
	case '}':
	case ',':
	case '<':
	   sprintf( dummy, "%s%c%s", c == '<' ? " " : "", c,
		    c == '<' || c == ',' ? " " : "" );
	   strcat( l, dummy );
	   j += 1;
	   break;
	case '^':
	   i += 1;
	   strcpy( dummy, opvalue( (int) *( str + i ) ) );
	   if ( j + strlen( dummy ) >= width ) return;
	   strcat( l, dummy );
	   j = strlen( l );
	   break;
     }
  }
} /* ord2str */

void treat_ordering( struct window_borders wb, struct ordering o )
{
   char l[ 201 ];

   focus_on_window( wb );
   ord2str( o.list, l, 200 );
   clrscr();
   display_auto_wrap( l, wb.x2 - wb.x1 );
}

/*
   Name       : edit_ordering.
   Function   : edit given ordering.
*/

void edit_ordering( struct ordering *orde )
{
   int c, i;
   int braces = 0, last = -1, lchosen = 0;
   struct window_borders wb, dis;
   char dummy[ 80 ], backup[ ORDERLEN + 1 ];

   strcpy( backup, orde->list );
   prepare_default_window( 5, GENERAL_UPPER_Y, 75, GENERAL_UPPER_Y + 14,
			   " Edit ordering ", &wb );
   ( void ) horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	    JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
   sprintf( dummy, " Ordering \'%s\' ", orde->ordname );
   ( void ) create_window( 6, GENERAL_UPPER_Y + 1, 74, GENERAL_UPPER_Y + 7,
			   LIGHTGRAY, BLACK, SINGLE_LINE_BOX, dummy );
   dis = create_window( 7, GENERAL_UPPER_Y + 2, 73, GENERAL_UPPER_Y + 6,
			LIGHTGRAY, BLACK, NO_BOX, 0 );
   ( void ) create_window( 6, GENERAL_UPPER_Y + 8, 74, GENERAL_UPPER_Y + 10,
			   LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   focus_on_window( wb );
   treat_ordering( dis, *orde );
   i = strlen( orde->list );
   if ( i >= 2 && orde->list[ i - 2 ] == '^' )
      last = TV;
   else if ( i >= 1 )
   {
      switch( orde->list[ i - 1 ] )
      {
	 case '{': last = LBRACE; break;
	 case '}': last = RBRACE; break;
	 case ',': last = COMMA;  break;
	 case '<': last = LESS;   break;
      }
   }
   for ( i = 0; i < strlen( orde->list ); i++ )
      if ( *( orde->list + i ) == '{' ) braces += 1;
      else if ( *( orde->list + i ) == '}' ) braces -= 1;
   do
   {
      do
      {
	 c = horizontal_select_menu( 7, GENERAL_UPPER_Y + 9, 65, !JUST_INIT,
				     OUT, max( 0, lchosen ), 6,
				     "  TV ", "'<'", "'{'", "'}'", "','" , "\x11\x11" );
	 lchosen = c;
	 i = ( c == TV ? 2 : 1 );
	 if ( c != -ESC && c != GO_ONE_BACK && strlen( orde->list ) + i > ORDERLEN )
	    confirm( "Order too long.", 1 );
	 else
         switch( c )
         {
	    case COMMA:
	       if ( last == RBRACE || last == TV )
	       {
	          strcat( orde->list, "," );
	          treat_ordering( dis, *orde );
                  last = COMMA;
	       }
	       else confirm( "',' only after truth value or '}'.", 1 );
	       break;
	    case LBRACE:
	       if ( last != RBRACE && last != TV )
	       {
	          strcat( orde->list, "{" );
	          treat_ordering( dis, *orde );
                  last = LBRACE;
	          braces += 1;
	       }
	       else confirm( "'{' not after truth value or '}'.", 1 );
	       break;
	    case RBRACE:
	       if ( braces >= 1 )
	       {
	          if ( last == RBRACE || last == TV )
	          {
	      	     strcat( orde->list, "}" );
		     treat_ordering( dis, *orde );
		     last = RBRACE;
		     braces -= 1;
	          }
		  else confirm( "'}' only after truth value or '}'.", 1 );
	       }
	       else confirm( "No matching '{'.", 1 );
	       break;
	    case LESS:
	       if ( ( last == RBRACE || last == TV ) )
	       {
	          strcat( orde->list, "<" );
	          treat_ordering( dis, *orde );
                  last = LESS;
	       }
	       else confirm( "'<' only after truth value or '}'.", 1 );
	       break;
	    case GO_ONE_BACK:
	       i = strlen( orde->list );
	       if ( i >= 2 )
	       {
	          if ( orde->list[ i - 2 ] == '^' )
		     i -= 2;
	          else i -= 1;
	          switch( orde->list[ i ] )
	          {
		     case '{': braces -= 1; break;
		     case '}': braces += 1; break;
	          }
	          orde->list[ i ] = '\0';
	          if ( i >= 2 && orde->list[ i - 2 ] == '^' )
		     last = TV;
		  else if ( i >= 1 )
		  {
		     switch( orde->list[ i - 1 ] )
		     {
			case '}': last = RBRACE; break;
			case '{': last = LBRACE; break;
			case '<': last = LESS; break;
			case ',': last = COMMA; break;
		     }
		  }
		  else last = -1;
	       }
	       else
	       {
		  switch( orde->list[ i - 1 ] )
		  {
		     case '{': braces -= 1; break;
		     case '}': braces += 1; break;
		  }
		  strcpy( orde->list, "\0" );
		  last = -1;
	       }
	       treat_ordering( dis, *orde );
	       break;
	    case TV:
	       if ( last != RBRACE && last != TV )
	       {
		  save_screen();
		  i = general_scroll_menu( 2, 3, min( tvnum, 5 ), 0,
		      LIGHTGRAY, BLACK, SINGLE_LINE_BOX, TRUTH_VALUES );
		  restore_screen();
		  if ( i >= 0 && i < tvnum )
	          {
		     sprintf( dummy, "^%c", i + INITIALIZED );
		     strcat( orde->list, dummy );
		     treat_ordering( dis, *orde );
                     last = TV;
	          }
	       }
	       else confirm( "Truth value not after preceeding truth value or '}'.", 1 );
	       break;
	 }
	 switch( c )
	 {
	    case -LEFT:
	    case -SHIFT_TAB: lchosen = GO_ONE_BACK; c = 42; break;
	    case -RIGHT:
	    case -TAB: lchosen = 0; c = 42; break;
	 }
      }
      while ( c >= 0 );
      c = horizontal_select_menu( wb.x1 + 2, wb.y2 - 2, wb.x2 - wb.x1 - 3,
	  !JUST_INIT, OUT, NO_INIT_POS, 2, "Accept", "Cancel" );
      if ( c < 0 ) c = -ESC;
   }
   while ( c == -ESC );
   if ( c == DO_CANCEL )
      strcpy( orde->list, backup );
   else changed = 1;
   main_window();
} /* edit_ordering */