/*
                   ########|       ######|   ######|
                     ####'/         `####|   ####'/
                     ####|           ####|  ,####|
    ,##########.\    ####|           ####| ####'/
   ####(     ####|   ####|           ########'/
   ##############|   ####|           ########.\
   ####'/            ####|           ####|`####.\
   ####|             ####|    ,##|   ####|  `####|
   ####.\    ####|   ####.\ ,####|  ,####|   ####.\
    `##########'/  ##############| ######|   ######|

   *L*ogic *K*reator (c) by \/\//\/ - July, 10th 1995

*/

/* Includes ********************************************************/
#define X 2
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "menu.h"
#include "edit.h"
#include "create.h"
#include "delete.h"
#include "help.h"
#include "file.h"
#include "view.h"


/* Variables ********************************************************/

/* The logic name */
extern char lgc_name[ LGCNAMELEN + 1 ];

/* Truth values and number of currently used tvs. */
extern char tv[ TVMAX ][ TVNAMELEN + 1 ];
extern int tvnum;
extern int maxlen;

extern struct op_list *op;
extern struct qu_list *qu;
extern struct ord_list *ord;

/* Prototypes ********************************************************/

void carry_out( int which );

void main()
{
   int c;

   draw_bare_necessities();
   display_about();
   do
   {
      cursor( 0 );
      c = get_key();
      cursor( 1 );
      switch( c )
      {
	 case CTRL_Q:
	    if ( !quit_elk() ) c = '!';
	    break;
	 case ALT_F:
	    carry_out( pull_down_menus( FILE_MENU ) );
	    break;
	 case F3:
	    carry_out( FILE_LOAD );
	    break;
	 case F2:
	    carry_out( FILE_SAVE );
	    break;
	 case ALT_C:
	    carry_out( pull_down_menus( CREATE_MENU ) );
	    break;
	 case ALT_E:
	    carry_out( pull_down_menus( EDIT_MENU ) );
	    break;
	 case ALT_V:
	    carry_out( pull_down_menus( VIEW_MENU ) );
	    break;
	 case F5:
	    carry_out( VIEW_VIEW_ALL );
	    break;
	 case ALT_D:
	    carry_out( pull_down_menus( DELETE_MENU ) );
	    break;
	 case ALT_O:
	    carry_out( pull_down_menus( OPTIONS_MENU ) );
	    break;
	 default:;
      }
   }
   while ( c != CTRL_Q );

}  /* main */

/*
   Name       : carry_out.
   Function   : an option of one of the menus has been activated, so do sthing.
*/

void carry_out( int which )
{
   switch( which )
   {
      case FILE_LOAD:
	 add_help( H_FILE_LOAD );
	 load();
         remove_help();
	 break;
      case FILE_SAVE:
	 add_help( H_FILE_SAVE );
	 save();
         remove_help();
	 break;
      case FILE_SAVE_AS:
	 add_help( H_FILE_SAVE_AS );
	 save_as();
	 remove_help();
	 break;
      case FILE_NEW:
	 purge_all( 0 );
	 break; /* New */
      case CREATE_LOGIC_NAME:
	 add_help( H_CREATE_LOGIC_NAME );
	 enter_lgc_name();
	 remove_help();
	 break;
      case CREATE_TRUTHVALUES:
	 add_help( H_CREATE_TRUTHVALUES );
	 enter_truth_values();
	 remove_help();
	 break;
      case CREATE_OPERATOR:
	 add_help( H_CREATE_OPERATOR );
	 create_operator();
         remove_help();
	 break;
      case CREATE_QUANTIFIER:
	 add_help( H_CREATE_QUANTIFIER );
	 create_quantifier();
         remove_help();
	 break;
      case CREATE_ORDERING:
	 add_help( H_CREATE_ORDERING );
	 create_ordering();
         remove_help();
	 break;
      case EDIT_DESIGNATED_TRUTHVALUES:
	 add_help( H_EDIT_DESIGNATED_TRUTHVALUES );
	 edit_designated_truth_values();
         remove_help();
	 break;
      case EDIT_OPERATOR:
	 add_help( H_EDIT_OPERATOR );
	 general_choose( OPERATORS );
         remove_help();
	 break;
      case EDIT_QUANTIFIER:
	 add_help( H_EDIT_QUANTIFIER );
	 general_choose( QUANTIFIERS);
         remove_help();
	 break;
      case EDIT_ORDERING:
	 add_help( H_EDIT_ORDERING );
	 general_choose( ORDERINGS );
         remove_help();
	 break;
      case VIEW_VIEW_ALL:
	 add_help( H_VIEW_VIEW_ALL );
	 display_values();
         remove_help();
	 break;
      case DELETE_OPERATOR:
	 general_delete( OPERATORS );
	 break;
      case DELETE_QUANTIFIER:
	 general_delete( QUANTIFIERS );
	 break;
      case DELETE_ORDERING:
	 general_delete( ORDERINGS );
	 break;
      case OPTIONS_BEEP:
	 toggle_beep_menu();
      case OPTIONS_REDRAW:
	 clrscr();
	 draw_bare_necessities();
	 break;
      case OPTIONS_ABOUT:
	 display_about();
	 break;
      case -1:
	 break;
      default:
	 display_error( "Invalid option." );
	 break;
   }
} /* carry_out */

