#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdarg.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "help.h"
#define HELP_BUFFER_SIZE 20

struct text_info t;
char buffer[ 80*25 ]; /* suffices for 1 full screen save */
unsigned char currently_helping = 0;
int help_buffer[ HELP_BUFFER_SIZE ] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
				 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };
int currently_used = -1;

void help();



void display_help()
{
   if ( currently_helping ) return;
   currently_helping = 1;
   gettextinfo( &t );
   gettext( HELP_X1 - 1, HELP_Y1 - 1, HELP_X2 + 1, HELP_Y2 + 1, &buffer );
   ( void ) create_window( HELP_X1 - 1, HELP_Y1 - 1, HELP_X2 + 1, HELP_Y2 + 1,
			   BLACK, LIGHTGRAY, SINGLE_LINE_BOX, " eLK - Help " );
   ( void ) create_window( HELP_X1, HELP_Y1, HELP_X2, HELP_Y2,
			   BLACK, LIGHTGRAY, NO_BOX, 0 );
   help( 0 );
   puttext( HELP_X1 - 1, HELP_Y1 - 1, HELP_X2 + 1, HELP_Y2 + 1, &buffer );
   window( t.winleft, t.wintop, t.winright, t.winbottom );
   textattr( t.attribute );
   gotoxy( t.curx, t.cury );
   currently_helping = 0;
}

void add_help( int i )
{
   if ( currently_used < HELP_BUFFER_SIZE )
      help_buffer[ currently_used += 1 ] = i;
   else
   {
      printf( "HELP.C: increase HELP_BUFFER_SIZE." );
      exit( 1 );
   }
}

void remove_help()
{
   if ( currently_used >= 0 ) currently_used -= 1;
   else
   {
      printf( "HELP.C, function remove_help: tried to decrease variable currently_used to -2." );
      exit( 1 );
   }
}

void help( )
{
   char *h;

   switch( currently_used >= 0 ? help_buffer[ currently_used ] :
	   H_GENERAL_HELP )
   {

case H_FILE_LOAD: h =
" Menu <File>, Load\n\r"
" =================\n\n\r"
" Loads an existing .LGC file.";break;
case H_FILE_SAVE: h =
" Menu <File>, Save\n\r"
" =================\n\n\r"
" Save the current logic. If the file name is not\n\r"
" specified you will be asked to do so.\n\n\r"
" If some of the mandatory parts of the logic,\n\r"
" which are\n\n\r"
"    LOGIC NAME, TRUTH VALUES\n\n\r"
" are missing, saving will not be possible.";break;
case H_FILE_SAVE_AS: h =
" Menu <File>, Save as\n\r"
" ====================\n\n\r"
" Save the current logic under a name which is to be\n\r"
" specified. If some of the mandatory parts of the\n\r"
" logic, which are\n\n\r"
"    LOGIC NAME, TRUTH VALUES\n\n\r"
" are missing, saving will not be possible.";break;
case H_FILE_NEW: h =
" Menu <File>, Save as\n\r"
" ====================\n\n\r"
" Purge the editor. You will be prompted, if you\n\r"
" choose this option."; break;
case H_CREATE_LOGIC_NAME: h=
" Menu <Create>, Logic name\n\r"
" =========================\n\n\r"
" Enter or change the name for the currently edited\n\r"
" logic. The logic name may consist of any printable\n\r"
" characters."; break;
case H_CREATE_TRUTHVALUES: h =
" Menu <Create>, Truth values\n\r"
" ===========================\n\n\r"
" Before any operator, quantifier or ordering can be\n\r"
" created, the truth values have to be defined. They\n\r"
" must match the regular expression\n\n\r"
" [a-z][a-z0-9_]*|[-+*^<>=~?@#$&]+|0|[1-9][0-9]*\n\n\r"
" Examples: 'a', 'tv_1', '+', '#-$', '0', '42'\n\r"
" Examples for invalid names:\n\r"
"           '9a', 'e*f*g', '_abcd'\n\n\r"
" Note: It is advisable to begin each truth value\n\r"
"       with a different character. The editing of\n\r"
"       mappings will be more comfortable."; break;
case H_CREATE_OPERATOR: h =
" Menu <Create>, Operator\n\r"
" =======================\n\n\r"
" Create an operator. Enter name, arity and type.\n\n\r"
" ACCEPT: Add the new operator, edit later,\n\r"
"           e.g.: if the ordering of an induced by-\n\r"
"           operator does not exist yet.\n\r"
" CANCEL: Discard the creation.\n\r"
" EDIT  : Add the new operator and edit it."; break;
case H_CREATE_QUANTIFIER: h =
" Menu <Create>, Quantifier\n\r"
" =========================\n\n\r"
" Create an quantifier. Enter name and type.\n\n\r"
" ACCEPT: Add the new quantifier, edit later,\n\r"
"           e.g.: if the ordering/operator of an\n\r"
"           induced by-quantifier does not exist\n\r"
"           yet.\n\r"
" CANCEL: Discard the creation.\n\r"
" EDIT  : Add the new quantifier and edit it."; break;
case H_CREATE_ORDERING: h =
" Menu <Create>, Ordering\n\r"
" =======================\n\n\r"
" Create an ordering. Enter name.\n\r"
" ACCEPT: Add the new ordering, edit later.\n\r"
" CANCEL: Discard the creation.\n\r"
" EDIT  : Add the new ordering and edit it."; break;
case H_EDIT_DESIGNATED_TRUTHVALUES: h =
" Menu <Edit>, Designated truth values\n\r"
" ====================================\n\n\r"
" ARROW KEYS: move amongst the truth values.\n\r"
" <ENTER> : Toggle designation of the currently\n\r"
"           marked truth value.\n\r"
" <ESC>   : Switch between table and bottom bar.\n\r"
" ACCEPT: Accept and exit.\n\r"
" CANCEL: Cancel changes and exit."; break;
case H_EDIT_OPERATOR: h =
" Menu <Edit>, Operator\n\r"
" =====================\n\n\r"
" Edit an operator.\n\r"
" Mapping, table:\n\r"
"   Use the arrow keys, <PGUP>, <PGDOWN>, <POS1> and\n\r"
"   <END> to scroll. If a key hit matches the first\n\r"
"   character of a truth value, the very one will be\n\r"
"   put at the current position. Hit <ENTER> or\n\r"
"   <ESC> for <ACCEPT>/<CANCEL> menu.\n\n\r"
" Induced-by operators:\n\r"
"   Edit the binary operator and the name of the\n\r"
"   ordering involved."; break;
case H_EDIT_QUANTIFIER: h =
" Menu <Edit>, Quantifier\n\r"
" =======================\n\n\r"
" Edit an quantifier.\n\r"
" Mapping:\n\r"
"   Use the arrow keys, <PGUP>, <PGDOWN>, <POS1> and\n\r"
"   <END> to scroll. If a key hit matches the first\n\r"
"   character of a truth value, the very one will be\n\r"
"   put at the current position. Hit <ENTER> or\n\r"
"   <ESC> for ACCEPT/CANCEL menu.\n\n\r"
" Induced-by quantifiers:\n\r"
"   Edit operator, the binary operator and the name\n\r"
"   of the ordering involved."; break;
case H_EDIT_ORDERING: h =
" Menu <Edit>, Ordering\n\r"
" =====================\n\n\r"
" Edit an ordering.\n\r"
" You are supplied with six buttons ( ',', '<', '{',\n\r"
" '}', 'TV' and 'DELETE' ). Move amongst them with\n\r"
" <LEFT> and <RIGHT>. Hit <ENTER> to add the current\n\r"
" symbol to the ordering. If it does not match\n\r"
" ( e.g.: '{' cannot follow '}' ), you will be\n\r"
" notified. Hit <ESC> for ACCEPT/CANCEL menu."; break;
case H_VIEW_VIEW_ALL: h =
" Menu <View>, View all\n\r"
" =====================\n\n\r"
" Designated truth values are marked with a '*'.\n\n\r"
" Operators, quantifiers and orderings which are\n\r"
" completely defined are also marked with a '*'."; break;
case H_DELETE_OPERATOR: h =
" Menu <Delete>, Operator\n\r"
" =======================\n\n\r"
" Select an operator for deletion. You have to\n\r"
" confirm this action."; break;
case H_DELETE_QUANTIFIER: h =
" Menu <Delete>, Quantifier\n\r"
" =========================\n\n\r"
" Select an quantifier for deletion. You have to\n\r"
" confirm this action."; break;
case H_DELETE_ORDERING: h =
" Menu <Delete>, Ordering\n\r"
" =======================\n\n\r"
" Select an ordering for deletion. You have to\n\r"
" confirm this action."; break;
case H_OPTIONS_BEEP: h =
" Menu <Options>, Beep\n\r"
" ====================\n\n\r"
" Shows the current state of the warning beep.\n\r"
" Hit <ENTER> to toggle it."; break;
case H_OPTIONS_REDRAW: h =
" Menu <Options>, Redraw\n\r"
" ======================\n\n\r"
" Redraws the screen."; break;
case H_ERROR: h =
" Error message\n\r"
" =============\n\n\r"
" Hit <ESCAPE> to resume."; break;
case H_E_RE2: h =
" Mismatch to regular expression\n\r"
" ==============================\n\n\r"
" The name does not match the regular expression\n\n\r"
" [a-z][a-z0-9_]*|[-+*^<>=~?@#$&]+|0|[1-9][0-9]*\n\n\r"
" In words: The name must meet exactly one of the\n\r"
" following conditions:\n\n\r"
" *) The name contains lowercase letters, digits and\n\r"
"    underscores, but must start with a letter.\n\r"
" *) It is a combination of at least one of the\n\r"
"    characters - + * ^ < > = ~ ? @ # $ &\n\r"
" *) It is a number without leading 0, except that\n\r"
"    the number itself is 0."; break;
default: h =
" General help page for eLK\n\r"                   /* ENDE */
" =========================\n\n\r"
" F1 : Help page.\n\r"
" F2 : Save logic.\n\r"
" F3 : Load logic.\n\r"
" F5 : View all.\n\r"
" ALT + <first key of menu>: Pull down menu."; break;
   }
   cprintf( "%s", h );
   cursor( 0 );
   esc_or_return();
   cursor( 1 );
}