/* Logic Specifikation **************************************************/

/* Operator struct */
struct operator {
   char opname[ OPNAMELEN + 1 ];   /* operator_name */
   char ordname[ OPNAMELEN + 1 ];  /* induced by ordering name */
   unsigned int power; 		   /* how many entries does the operator have? */
   int arity;          /* arity - any questions ;-) */
   int typ;            /* 0: mapping, 1: table, 10: lub, 11: sup, 20: glb, 21: inf */
		       /* Use the defines in lgc_head. The numbers are arbitrary. */
   char *list;         /* list of characters that actually hold the tvs */
};

struct op_list {
   struct operator o;
   struct op_list *next;
};

/* Quantifier struct */
struct quantifier {
   char quname[ QUNAMELEN + 1 ];   /* quantifier name */
   char oporord[ max( OPNAMELEN, ORDNAMELEN ) + 1 ]; /* operator/ordering name */
   unsigned int power; /* how many entries does the operator have?             */
   int typ;            /* is it mapping or induced by inf/lub/sup/glb/operator */
   int arity;          /* used if induced by operator */
   char *list;
};

struct qu_list {
   struct quantifier q;
   struct qu_list *next;
};

/* Ordering struct */
struct ordering {
   char ordname[ ORDNAMELEN + 1 ];    /* ordering name */
   char list[ ORDERLEN + 1 ];  /* ordering string ( coded ) */
};

struct ord_list {
   struct ordering or;
   struct ord_list *next;
};