/*********************************************************************/
/*                                                                   */
/*       G L O B A L   D E F I N E S   F O R   T H E   e L K         */
/*                                                                   */
/*                       !!!!!!                                      */
/*     D O N ' T   C H A N G E   T H E M   U N L E S S   Y O U       */
/*     * R E A L L Y *   K N O W ,   W H A T   Y O U '   R E         */
/*                      D O I N G                                    */
/*                       !!!!!!					     */
/*                                                                   */
/*        ( U S U A L L Y   Y O U   D O N ' T ;-P )                  */
/*                                                                   */
/*********************************************************************/

/* Defines for menus ************************************************/

#define MENUS 6
#define MENU_DEPTH 5

#define FILE_MENU                      0
#define CREATE_MENU                    1
#define EDIT_MENU                      2
#define VIEW_MENU                      3
#define DELETE_MENU		       4
#define OPTIONS_MENU 		       5

#define FILE_LOAD                      MENU_DEPTH*FILE_MENU + 0
#define FILE_SAVE                      MENU_DEPTH*FILE_MENU + 1
#define FILE_SAVE_AS                   MENU_DEPTH*FILE_MENU + 2
#define FILE_NEW                       MENU_DEPTH*FILE_MENU + 3

#define CREATE_LOGIC_NAME              MENU_DEPTH*CREATE_MENU + 0
#define CREATE_TRUTHVALUES             MENU_DEPTH*CREATE_MENU + 1
#define CREATE_OPERATOR                MENU_DEPTH*CREATE_MENU + 2
#define CREATE_QUANTIFIER              MENU_DEPTH*CREATE_MENU + 3
#define CREATE_ORDERING                MENU_DEPTH*CREATE_MENU + 4

#define EDIT_DESIGNATED_TRUTHVALUES    MENU_DEPTH*EDIT_MENU + 0
#define EDIT_OPERATOR                  MENU_DEPTH*EDIT_MENU + 1
#define EDIT_QUANTIFIER                MENU_DEPTH*EDIT_MENU + 2
#define EDIT_ORDERING                  MENU_DEPTH*EDIT_MENU + 3

#define VIEW_VIEW_ALL                  MENU_DEPTH*VIEW_MENU + 0

#define DELETE_OPERATOR                MENU_DEPTH*DELETE_MENU + 0
#define DELETE_QUANTIFIER              MENU_DEPTH*DELETE_MENU + 1
#define DELETE_ORDERING                MENU_DEPTH*DELETE_MENU + 2

#define OPTIONS_BEEP                   MENU_DEPTH*OPTIONS_MENU + 0
#define OPTIONS_REDRAW                 MENU_DEPTH*OPTIONS_MENU + 1
#define OPTIONS_ABOUT                  MENU_DEPTH*OPTIONS_MENU + 2
/* Defines for special keystrokes ************************************/

#define UP 		328
#define DOWN 		336
#define LEFT 		331
#define RIGHT 		333
#define ESC 		27
#define RETURN 		13
#define CTRL_Q 		17
#define F1 		315
#define F2 		316
#define F3 		317
#define F4 		318
#define F5 		319
#define F6 		320
#define F7 		321
#define F8 		322
#define ALT_A 		286
#define ALT_C 		302
#define ALT_D		288
#define ALT_E 		274
#define ALT_F 		289
#define ALT_H 		291
#define ALT_O		280
#define ALT_V 		303
#define BACKSPACE 	8
#define PGUP 		329
#define PGDOWN 		337
#define END 		335
#define POS1 		327
#define TAB		9
#define SHIFT_TAB	271

/* Defines for logic specifikation ***********************************/

#define MAX_ARITY 		10
#define TVMAX 			20
#define MAPPING    		0
#define TABLE 			1
#define GLB 			2
#define INF 			3
#define LUB 			4
#define SUP 			5
#define INDUCED_BY_OPERATOR     6
#define INDUCED_BY_INF		INF
#define INDUCED_BY_GLB		GLB
#define INDUCED_BY_SUP		SUP
#define INDUCED_BY_LUB		LUB

/* Defines for names limits ******************************************/

#define OPNAMELEN 	10
#define QUNAMELEN 	10
#define TVNAMELEN 	10
#define ORDNAMELEN 	10
#define ORDERLEN	100
#define LGCNAMELEN 	20
#define NOT_INITIALIZED 32        /* DO NOT CHANGE THIS VALUE BELOW 32 !! */
#define INITIALIZED 	NOT_INITIALIZED + 1

/* Defines for window measures ***************************************/

#define MAIN_WINDOW_LENGTH 		21
#define MAIN_WINDOW_WIDTH 		78
#define SCROLL_WINDOW_LENGTH 		19
#define GENERAL_UPPER_Y                 3

/* Defines for miscancellous stuff ***********************************/

#define CLR_BASE 	0xB800
#define SAVE_SCREENS 	3
#define JUST_INIT	1
#define OUT		1
#define NO_INIT_POS     0
#define TRUTH_VALUES    0
#define OPERATORS       1
#define QUANTIFIERS     2
#define ORDERINGS       3
#define BIN_OPS         4

/* Simplifying defines ***********************************************/

#define TATTR( X, Y ) 		textattr( X * 16 + Y )
#define OUTXY( XX, YY, ZZ ) 	gotoxy( XX, YY), cprintf( "%s", ZZ )
#define OUTREDXY( XX, YY, ZZ, ZZZ ) gotoxy( XX, YY), in_red( ZZ, ZZZ )

