/* Includes ********************************************************/
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "adfulo.h"
#include "help.h"
#include "menu.h"

/* Variables ********************************************************/

/* Menu thingies */

char *menu_titles[ MENUS ] = {
		"File", "Create", "Edit", "View", "Delete", "Options" };
char *menu_choices[ MENUS ][ MENU_DEPTH ] = {
		"Load    F3",
		"Save    F2",
		"Save as",
		"New", "\0",
		"Logic name",
		"Truthvalues",
		"Operator",
		"Quantifier",
		"Ordering",
		"Designated truthvalues",
		"Operator",
		"Quantifier",
		"Ordering", "\0",
		"View all   F5", "\0", "\0", "\0", "\0",
		"Operator",
		"Quantifier",
		"Ordering", "\0", "\0",
		"Beep is: OFF",
		"Redraw",
		"About", "\0", "\0" };
int menu_position[ MENUS ] = { 0, 0, 0, 0, 0, 0 };


/*
   Name       : display_menu.
   Function   : display the menu 'menu'.
*/

void display_menu( int menu )
{
   int i, entry_width = 0, d = 0, where = 4;

   for ( i = 0; i < MENU_DEPTH; i++ )
   {
      if ( strcmp( menu_choices[ menu ][ i ], "\0" ) == 0 ) d += 1;
      if ( strlen( menu_choices[ menu ][ i ] ) > entry_width )
	 entry_width = strlen( menu_choices[ menu ][ i ] );
   }
   for ( i = 0; i < menu; i++ )
      where += 3 + strlen( menu_titles[ i ] );
   window( 1, 1, 80, 1 );
   inverse( where, 1, menu_titles[ menu ], WHITE );
   if ( where + entry_width > 76 )
      where -= ( 76 - where - entry_width );
   ( void ) create_window( where, 2, where + entry_width + 3, 3 + MENU_DEPTH - d,
		  LIGHTGRAY, BLACK, SINGLE_LINE_BOX, 0 );
   for ( i = 0; i < MENU_DEPTH - d; i++)
   {
      gotoxy( 3, i + 2 ); cprintf( "%s", menu_choices[ menu ][ i ] );
   }
   highlight_menu( menu, menu_position[ menu ] );
} /* display_menu */

/*
   Name       : highlight_menu.
   Function   : highlight in menu "menu" the "num"-th entry.
*/

void highlight_menu( int menu, int num )
{
   inverse( 3, num + 2, menu_choices[ menu ][ num ], WHITE );
   TATTR( LIGHTGRAY, BLACK );
} /* highlight_menu */

/*
   Name       : normal_menu.
   Function   : dehighlight in menu "menu" the "num"-th entry.
*/

void normal_menu( int menu, int num )
{
   inverse( 3, num + 2, menu_choices[ menu ][ num ], 16*LIGHTGRAY );
} /* normal_menu */

void draw_bare_necessities()
{
   TATTR( BLACK, LIGHTGRAY );
   clrscr();
   menu_strips( 2 );
   screen();
   TATTR( BLACK, LIGHTRED );
   big_title();
   screen();
}

/*
   Name       : menu_strips.
   Function   : displays the menu strips on top of the screen.
   Comments   : is to be called only once at the drawing of the screen.
*/

void menu_strips( int which )
{
   int i;
   char *s;

   if ( which != 1 )
   {
      window( 1, 1, 80, 1 );
      textbackground( LIGHTGRAY );
      clrscr();
      for ( i = 0; i < MENUS; i++ )
      {
	 gotoxy( wherex() + 3, wherey() );
	 textcolor( RED );
	 cprintf( "%c", *menu_titles[ i ] );
	 textcolor( BLACK );
	 s = menu_titles[ i ] + 1;
	 cprintf( "%s", s );
      }
   }
   if ( which != 0 )
   {
      window( 1, 25, 80, 25 );
      clrscr();
      OUTREDXY( 5, 1, "F1", BLACK );           cprintf( "-Help" );
      OUTREDXY( wherex() + 3, 1, "^Q", BLACK );  cprintf( "-Quit" );
      TATTR( BLACK, LIGHTGRAY );
   }
} /* menu_strips */

/*
   Name       : pull_down_menus.
   Function   : display menus and handle cursor movement for it, return
		the chosen option, -1 if ESC is pressed.
*/

int pull_down_menus( int menu )
{
   int c, i;

   if ( menu >= MENUS )
      menu = MENUS - 1;
   save_screen();
   display_menu( menu );
   do
   {
      add_help( menu*MENU_DEPTH + menu_position[ menu ] );
      cursor( 0 );
      c = get_key();
      cursor( 1 );
      switch( c )
      {
	 case UP:
	    normal_menu( menu, menu_position[ menu ] );
	    if ( ( menu_position[ menu ] -= 1 ) == -1 )
	    {
	       menu_position[ menu ] = MENU_DEPTH - 1;
	       for ( i = MENU_DEPTH - 1; i >= 0; i-- )
		  if ( strcmp( menu_choices[ menu ][ i ], "\0" ) == 0 )
		     menu_position[ menu ] -= 1;
	    }
	    highlight_menu( menu, menu_position[ menu ] );
	    break;
	 case DOWN:
	    normal_menu( menu, menu_position[ menu ] );
	    if ( ( menu_position[ menu ] += 1 ) == MENU_DEPTH ||
		 strcmp( menu_choices[ menu ][ menu_position[ menu ] ], "\0" ) == 0 )
	       menu_position[ menu ] = 0;
	       highlight_menu( menu, menu_position[ menu ] );
	    break;
	 case LEFT:
	    if ( ( menu -= 1 ) == -1 ) menu = MENUS - 1;
	 /*   menu_strips( 0 );     */
	    restore_screen();
	    save_screen();
	    display_menu( menu );
	    break;
	 case RIGHT:
	    if ( ( menu += 1 ) == MENUS ) menu = 0;
	 /*   menu_strips( 0 ); */
	    restore_screen();
	    save_screen();
	    display_menu( menu );
	    break;
	 case RETURN: break;
	 default:;
      }
      remove_help();
   }
   while ( c != ESC && c != RETURN );
   restore_screen();
   if ( c == RETURN ) return( MENU_DEPTH * menu + menu_position[ menu ] );
   return( -1 );
} /* pull_down_menus */

void toggle_beep_menu()
{
   char *s;
   int i;

   i = OPTIONS_BEEP - MENU_DEPTH*OPTIONS_MENU;
   s = menu_choices[ OPTIONS_MENU ][ i ] + 9;
   if ( toggle_beep() )
   {
      *s = ' ';
      *( s + 1 ) = 'O';
      *( s + 2 ) = 'N';
   }
   else
   {
      *s = 'O';
      *( s + 1 ) = 'F';
      *( s + 2 ) = 'F';
   }
}
