#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "lgc_head.h"
#include "lgc_def.h"
#include "bafulo.h"
#include "adfulo.h"
#include "view.h"
#define NOT  return display_error( "Out of memory." ), main_window(), 0;

extern char lgc_name[ LGCNAMELEN + 1 ];

extern char tv[ TVMAX ][ TVNAMELEN + 1 ];
extern int tvnum;
extern int maxlen;

extern struct op_list *op;
extern struct qu_list *qu;
extern struct ord_list *ord;

extern long dtv;

extern unsigned char changed;

/*
   Name       : display_values.
   Function   : display various values.
*/

int display_values()
{
   int i, j, how_many = 0;
   struct op_list *hop;
   struct qu_list *hqu;
   struct ord_list *hord;
   struct window_borders wb;
   char **str;

   how_many = how_many_operators() + how_many_quantifiers() +
	      how_many_orderings();
   if ( how_many )
   {
      str = (char **)malloc( sizeof( char * )*how_many );
      if ( str == NULL ) NOT;
      i = 0;
      hop = op;
      while ( hop != NULL )
      {
	 char st = ' ';

	 str[ i ] = (char *)malloc( sizeof( char )*( OPNAMELEN + 5 ) );
	 if ( str[ i ] == NULL ) NOT;
	 switch( hop->o.typ )
	 {
	    case MAPPING:
	    case TABLE:
	       if ( complete( hop->o.list ) ) st = '*';
	       break;
	    case GLB:
	    case INF:
	    case LUB:
	    case SUP:
	       if ( strlen( hop->o.ordname ) != 0 ) st = '*';
	       break;
	    default:;
	 }
	 sprintf( str[ i ], "%s/%d%c", hop->o.opname, hop->o.arity, st );
	 i += 1;
	 hop = hop->next;
      }
      hqu = qu;
      while ( hqu != NULL )
      {
	 char st = ' ';

	 str[ i ] = (char *)malloc( sizeof( char )*( QUNAMELEN + 4 ) );
	 if ( str[ i ] == NULL ) NOT;
	 switch( hqu->q.typ )
	 {
	    case MAPPING:
	       if ( complete( hqu->q.list ) ) st = '*';
	       break;
	    case GLB:
	    case INF:
	    case LUB:
	    case SUP:
	    case INDUCED_BY_OPERATOR:
	       if ( strlen( hqu->q.oporord ) != 0 ) st = '*';
	       break;
	    default:;
	 }
	 sprintf( str[ i ], "%s/q%c", hqu->q.quname, st );
	 i += 1;
	 hqu = hqu->next;
      }
      hord = ord;
      while ( hord != NULL )
      {
	 char st = ' ';

	 str[ i ] = (char *)malloc( sizeof( char )*( ORDNAMELEN + 6 ) );
	 if ( str[ i ] == NULL ) NOT;
	 if ( strlen( hord->or.list ) ) st = '*';
	 sprintf( str[ i ], "%s/ord%c", hord->or.ordname, st );
	 i += 1;
	 hord = hord->next;
      }
   }
   wb = create_window( 3, GENERAL_UPPER_Y, 78,
	GENERAL_UPPER_Y + 4 + min( how_many, 9 ) + ( how_many ? 2 : 0 ) +
	( tvnum ? tvnum/4 + 1 : 0 ), LIGHTGRAY, BLACK, DOUBLE_LINE_BOX,
	" View all " );
   gotoxy( wb.x2 - wb.x1 - 33, wb.y2 - wb.y1 );
   cprintf( "Hit <ESC> or <ENTER> to resume..." );
   gotoxy( 3, 2 );
   cprintf( "  Logic name: \"%s\"", strlen( lgc_name ) ? lgc_name : "\0" );
   OUTXY( 3, 3,
	    "Truth values: " );
   if ( tvnum == 0 )
      OUTREDXY( wherex(), wherey(), "Not speficied.", BLACK );
   else
   {
      long ex = 1;

      for ( i = 0; i < tvnum; i += 4 )
      {
	 gotoxy( 2, wherey() + 1 );
	 for ( j = i; j < i + 4 && j < tvnum; j++ )
	 {
	     cprintf( "%2d: %c%-12s", j + 1, ( ex & dtv ) == ex ? '*' : ' ',
		      tv[ j ] );
	     ex *= 2;
	 }
      }
   }
   if ( !how_many )
   {
      esc_or_return();
      main_window();
      return( 0 );
   }
   else ( void ) scroll_menu( str, how_many, 30, wb.y1 + wherey(),
	min( how_many, 9 ), NO_INIT_POS, LIGHTGRAY, BLACK, SINGLE_LINE_BOX );
   main_window();
   for ( i = 0; i < how_many; i++ ) free( str[ i ] );
   free( str );
   return( 0 );
} /* display_values */